{Code Edit April to August 1998
 1.5 September 1999}
unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs, Menus,
  StdCtrls, ExtCtrls, Buttons, ComCtrls,
  ToolWin, Printers, FileCtrl,
  CE_Unit, ReuUnit, ShellAPI, clipbrd;

type
  TViewMenuItem = class (TMenuItem)
  public
    procedure Assign (Source : TPersistent); override;
    procedure Click; override;
  end;

  TRunMenuItem = class (TMenuItem)
  public
    procedure Click; override;
  end;

  TRecentMenuItem = class (TMenuItem)
  public
    procedure Suicide;
    procedure Click; override;
  end;

  TGroupMenuItem = class (TMenuItem)
  public
    procedure Click; override;
    procedure Assign (Source : TPersistent); override;
  end;

  TFavMenuItem = class (TMenuItem)
  public
    procedure Suicide;
    procedure Click; override;
  end;

  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    FileMnu: TMenuItem;
    FileOpenMnu: TMenuItem;
    FileSaveMnu: TMenuItem;
    FileSaveAsMnu: TMenuItem;
    FileExitMnu: TMenuItem;
    EditMnu: TMenuItem;
    OptionsMnu: TMenuItem;
    OptionsEnvironmentMnu: TMenuItem;
    N2: TMenuItem;
    FilePrintMnu: TMenuItem;
    N3: TMenuItem;
    OptionsFontMnu: TMenuItem;
    FileNewMnu: TMenuItem;
    EditCutMnu: TMenuItem;
    EditCopyMnu: TMenuItem;
    EditPasteMnu: TMenuItem;
    FileCloseMnu: TMenuItem;
    ViewMnu: TMenuItem;
    SearchMnu: TMenuItem;
    SearchFindMnu: TMenuItem;
    SearchSearchAgainMnu: TMenuItem;
    SearchReplaceMnu: TMenuItem;
    N1: TMenuItem;
    SearchGotoLineNumberMnu: TMenuItem;
    HelpMnu: TMenuItem;
    EditDeleteMnu: TMenuItem;
    EditSelectAllMnu: TMenuItem;
    Timer1: TTimer;
    StatusBar1: TStatusBar;
    ToolBar: TPanel;
    NewSpdBtn: TSpeedButton;
    OpenSpdBtn: TSpeedButton;
    PrintSpdBtn: TSpeedButton;
    SaveSpdBtn: TSpeedButton;
    FindSpdBtn: TSpeedButton;
    SearchAgainSpdBtn: TSpeedButton;
    ReplaceSpdBtn: TSpeedButton;
    FileSaveAllMnu: TMenuItem;
    CutSpdBtn: TSpeedButton;
    CopySpdBtn: TSpeedButton;
    PasteSpdBtn: TSpeedButton;
    FontDialog1: TFontDialog;
    ViewNextMnu: TMenuItem;
    ViewPreviousMnu: TMenuItem;
    N6: TMenuItem;
    PopupMenu1: TPopupMenu;
    NextPopItem: TMenuItem;
    PreviousPopItem: TMenuItem;
    N7: TMenuItem;
    CutPopItem: TMenuItem;
    CopyPopItem: TMenuItem;
    PastePopItem: TMenuItem;
    DeletePopItem: TMenuItem;
    N8: TMenuItem;
    PropertiesPopItem: TMenuItem;
    WrapMnu: TMenuItem;
    N4: TMenuItem;
    RunMnu: TMenuItem;
    OptionsRunMnu: TMenuItem;
    EditUndoMnu: TMenuItem;
    PrintDlg: TPrintDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    FilePrintSetupMnu: TMenuItem;
    NextSpdBtn: TSpeedButton;
    PreviousSpdBtn: TSpeedButton;
    ExecuteMnu: TMenuItem;
    ExecuteCurrentFileMnu: TMenuItem;
    ExecuteDOSPromptMnu: TMenuItem;
    OptionsExecuteMnu: TMenuItem;
    FileReloadMnu: TMenuItem;
    EditDeleteLineMnu: TMenuItem;
    N5: TMenuItem;
    ExecuteDOSComMnu: TMenuItem;
    N9: TMenuItem;
    OptionsReadOnlyMnu: TMenuItem;
    HelpAboutMnu: TMenuItem;
    UpDown1: TUpDown;
    N10: TMenuItem;
    EditCutLineMnu: TMenuItem;
    N12: TMenuItem;
    N11: TMenuItem;
    ExecuteSpdBtn: TSpeedButton;
    OptionsScrollBarsMnu: TMenuItem;
    CloseSpdBtn: TSpeedButton;
    SaveAllSpdBtn: TSpeedButton;
    UndoSpdBtn: TSpeedButton;
    OptionsToolbarMnu: TMenuItem;
    N15: TMenuItem;
    FileRecentMnu: TMenuItem;
    FileOpenGroupMnu: TMenuItem;
    OptionsOpenGroupMenu: TMenuItem;
    FileCopyMnu: TMenuItem;
    FileMoveMnu: TMenuItem;
    N16: TMenuItem;
    FileOperationsMnu: TMenuItem;
    FileRenameMnu: TMenuItem;
    FileDeleteMnu: TMenuItem;
    N17: TMenuItem;
    FileFavoritesMnu: TMenuItem;
    OptionsOpenFavoritesMnu: TMenuItem;
    FileAddMnu: TMenuItem;
    AddFavoritesMnu: TMenuItem;
    AddGroupMnu: TMenuItem;
    HelpContentsMnu: TMenuItem;
    OptionsHintsMnu: TMenuItem;
    ViewSelectFileMnu: TMenuItem;
    AddToPopItem: TMenuItem;
    OptionsStatusMnu: TMenuItem;
    ViewSpdBtn: TSpeedButton;
    N13: TMenuItem;
    HelpSpdBtn: TSpeedButton;
    FileBackupMnu: TMenuItem;
    FileBackupCurrentFileMnu: TMenuItem;
    FileBackupAllFilesMnu: TMenuItem;
    FileCloseCurrentFileMnu: TMenuItem;
    FileCloseGroupMnu: TMenuItem;
    FileCloseAllFilesMnu: TMenuItem;
    FileInsertMnu: TMenuItem;
    FileUnbackupMnu: TMenuItem;
    FileUnbackupCurrentFileMnu: TMenuItem;
    FileUnbackupAllFilesMenu: TMenuItem;
    N14: TMenuItem;
    FileReplaceMnu: TMenuItem;
    FileReplaceCurrentFileMnu: TMenuItem;
    FileReplaceAllFilesMnu: TMenuItem;
    Edit: TRichEdit;
    FileSelectionMnu: TMenuItem;
    FileSelectionSaveMnu: TMenuItem;
    FileSelectionOpenMnu: TMenuItem;
    EditSwapClipMnu: TMenuItem;
    ExecuteExplorerMnu: TMenuItem;
    OptionsSyntaxMnu: TMenuItem;
    ViewMainFileMnu: TMenuItem;
    OpenGroupPopItem: TMenuItem;
    N18: TMenuItem;
    ClosePopItem: TMenuItem;
    OptionsPropertiesMnu: TMenuItem;
    OptionsOpenRecentMmu: TMenuItem;
    OptionsShowClipMnu: TMenuItem;
    N19: TMenuItem;
    EditIndentBlockMnu: TMenuItem;
    EditUnindentBlockMnu: TMenuItem;
    procedure FileOpenMnuClick(Sender: TObject);
    procedure FileSaveMnuClick(Sender: TObject);
    procedure FileSaveAsMnuClick(Sender: TObject);
    procedure FileExitMnuClick(Sender: TObject);
    procedure SearchFindMnuClick(Sender: TObject);
    procedure SearchReplaceMnuClick(Sender: TObject);
    procedure FilePrintMnuClick(Sender: TObject);
    procedure OptionsFontMnuClick(Sender: TObject);
    procedure OptionsEnvironmentMnuClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FileNewMnuClick(Sender: TObject);
    procedure EditSelectAllMnuClick(Sender: TObject);
    procedure EditCutMnuClick(Sender: TObject);
    procedure EditCopyMnuClick(Sender: TObject);
    procedure EditPasteMnuClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure EditChange(Sender: TObject);
    procedure SearchSearchAgainMnuClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ReplaceDialog1Show(Sender: TObject);
    procedure FileSaveAllMnuClick(Sender: TObject);
    procedure EditDeleteMnuClick(Sender: TObject);
    procedure ViewNextMnuClick(Sender: TObject);
    procedure ViewPreviousMnuClick(Sender: TObject);
    procedure SearchGotoLineNumberMnuClick(Sender: TObject);
    procedure WrapMnuClick(Sender: TObject);
    procedure EditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EditMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure EditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure OptionsRunMnuClick(Sender: TObject);
    procedure EditUndoMnuClick(Sender: TObject);
    procedure EditKeyPress(Sender: TObject; var Key: Char);
    procedure FilePrintSetupMnuClick(Sender: TObject);
    procedure EditMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ExecuteDOSPromptMnuClick(Sender: TObject);
    procedure OptionsExecuteMnuClick(Sender: TObject);
    procedure ExecuteCurrentFileMnuClick(Sender: TObject);
    procedure FileReloadMnuClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure EditDeleteLineMnuClick(Sender: TObject);
    procedure ExecuteDOSComMnuClick(Sender: TObject);
    procedure OptionsReadOnlyMnuClick(Sender: TObject);
    procedure HelpAboutMnuClick(Sender: TObject);
    procedure EditMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure EditCutLineMnuClick(Sender: TObject);
    procedure OptionsScrollBarsMnuClick(Sender: TObject);
    procedure OptionsToolbarMnuClick(Sender: TObject);
    procedure FileMnuClick(Sender: TObject);
    procedure OptionsOpenGroupMenuClick(Sender: TObject);
    procedure FileCloseGroupMnuClick(Sender: TObject);
    procedure FileCopyMnuClick(Sender: TObject);
    procedure FileMoveMnuClick(Sender: TObject);
    procedure FileRenameMnuClick(Sender: TObject);
    procedure FileDeleteMnuClick(Sender: TObject);
    procedure OptionsOpenFavoritesMnuClick(Sender: TObject);
    procedure HelpContentsMnuClick(Sender: TObject);
    procedure OptionsHintsMnuClick(Sender: TObject);
    procedure ViewSelectFileMnuClick(Sender: TObject);
    procedure OptionsStatusMnuClick(Sender: TObject);
    procedure FileBackupMnuClick(Sender: TObject);
    procedure FileBackupCurrentFileMnuClick(Sender: TObject);
    procedure FileBackupAllFilesMnuClick(Sender: TObject);
    procedure FileCloseCurrentFileMnuClick(Sender: TObject);
    procedure FileCloseAllFilesMnuClick(Sender: TObject);
    procedure FileInsertMnuClick(Sender: TObject);
    procedure FileUnbackupCurrentFileMnuClick(Sender: TObject);
    procedure FileUnbackupAllFilesMenuClick(Sender: TObject);
    procedure FileReplaceCurrentFileMnuClick(Sender: TObject);
    procedure FileReplaceAllFilesMnuClick(Sender: TObject);
    procedure FileSelectionSaveMnuClick(Sender: TObject);
    procedure FileSelectionOpenMnuClick(Sender: TObject);
    procedure EditSwapClipMnuClick(Sender: TObject);
    procedure ExecuteExplorerMnuClick(Sender: TObject);
    procedure OptionsSyntaxMnuClick(Sender: TObject);
    procedure ViewMainFileMnuClick(Sender: TObject);
    procedure AddFavoritesMnuClick(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure OptionsPropertiesMnuClick(Sender: TObject);
    procedure OptionsOpenRecentMmuClick(Sender: TObject);
    procedure OptionsShowClipMnuClick(Sender: TObject);
    procedure EditIndentBlockMnuClick(Sender: TObject);
    procedure EditUnindentBlockMnuClick(Sender: TObject);
  private
    { Private declarations }
    WinNum : byte;
    LastSelLength, LastStart : word;
    DoCBtoPanel : boolean;

    //for propoerties
    FFileName : TFileName;
    FInsert : boolean;

    procedure SetFileName (const s : TFileName);
    procedure SetInsert (b : boolean);

    property Insert : boolean
      read FInsert
      write SetInsert;

    procedure ChangeModify (b : boolean);
    procedure WriteModified;
    procedure OnAppActivate (Sender : TObject);
    procedure OnAppDeactivate (Sender : TObject);
    procedure EnableMenus (b : boolean);
    function EditToAry : boolean;
    function AryToEdit : boolean;
    procedure SaveOptions;
    procedure NewMenuItem (i : byte; const fName : TFileName);
    procedure EnableView;
    function CloseCurFile : boolean;
    procedure CloseCurFileOnError;
    function SaveChanges (i : byte) : word;
    procedure SetWrap (b : boolean);
    procedure EnableCutCopy;
    procedure SaveCurFile;
    procedure WriteCursPos;
    procedure ChangeColor;
    procedure ChangeReadOnly (b : boolean);
    function OpenParam : boolean;
    procedure SetScrollBars;
    function CanOpen (const fName : TFileName; b : boolean) : TCanOpen;
    //function FileTooBig (fName : TFileName): boolean;
    function AnyModified : boolean;
    procedure AddRecentNums;
    procedure DeleteRecentNums;
    function IsOpen (const fName : TFileName) : boolean;
    function CanAddToRecent (const fName : TFileName) : boolean;
    function RemoveFromRecent (const fName : TFileName) : boolean;
    function RecentPos (const fName : TFileName) : integer;
    function RemoveFromGroup (const fName : TFileName) : boolean;
    function AddToGroup (const fName : TFileName; b : boolean) : boolean;
    function InFav (const fName : TFileName) : SmallInt;
    procedure ShowStatusBar (b : boolean);
    function GetBackupName (const fName : TFileName) : TFileName;
    function IsOptionsFile (const fName : TFileName; b : boolean) : boolean;
    //function IsTooBig (fName : TFileName; b : boolean) : boolean;
    //procedure ShowUnregMsg;
    {procedure Highlight (start, stop : cardinal);
    procedure Highlight2 (start, stop : cardinal);
    procedure Highlight3 (start, stop : cardinal);
    procedure DoHighlight (start, stop : cardinal; i : integer);
    procedure DoHighlight2 (start, stop : cardinal; i : integer);}
    procedure SelectionToFile (const fName : TFileName);
    function GetMainFile : string;
    procedure CreatePopUpMenu;
    procedure CBtoPanel;
  public
    { Public declarations }
    FindText : string;
    //SourceDir : string;
    ColorScheme : TColorScheme;
    CustomFore, CustomBack : TColor;
    KeyMap : TKeyMap;
    FilesOpen, UntitledCount : byte;
    EndFindPosition, FindPosition : cardinal;
    NumOfRecs, StartWith : byte;
    Progs : array[1..MaxRecNum] of ^TProg;
    ExeOpts : TExeOpts;
    groups : array[1..MaxMenuRows] of ^TStringList;
    MainFile : array[1..MaxMenuRows] of integer;
    GroupOpen : byte;
    Files : array[1..MaxFiles - 1] of ^TFile;//1 in Edit
    DefViewNum : byte;
    BackupExt : TBackupExt;
    CanOpenOptions, ShowPathsChecked : boolean;
    ConfirmPrompt, PersistentGroups : boolean;
    MaxRecentNum : Cardinal;

    property FileName : TFileName
      read FFileName
      write SetFileName;

    function AddToRecent (const fName : TFileName; check : boolean) : boolean;
    procedure ChangeKeyMap (inKeyMap : TKeyMap);
    procedure NextUntitled;
    procedure ShowEdit;
    function Search (const Options : TSearchTypes): boolean;
    procedure SwapMemoAry (i : byte);
    procedure AssignColorScheme (i : byte);
    procedure ShowToolBar (b : boolean);
    function ChangeGroupFile (const f1, f2 : TFileName) : boolean;
    function OpenFileBack (const fName : TFileName; b1, b2 : boolean) : TCanOpen;
    function OpenFile (const fName : TFileName; b : boolean) : TCanOpen;
    function AddToFav (const fName : TFileName) : boolean;
    function ChangeFavFile (const OldName, NewName : TFileName) : boolean;
    function ChangeRecentFile (const OldName, NewName : TFileName) : boolean;
    function CloseAllFiles : boolean;
    function IntToBackupExt (i : integer) : TBackupExt;
    function CanAddTo (const fName : TFileName) : boolean;
    function CloseOpenGroup : boolean;
    function InCurGroup (const fName : TFileName) : boolean;
    function GetCaretY : cardinal;
    procedure ShowFoundDlg (FoundOne : boolean);
    function ExpandParams (var Params : string) : boolean;
  end;

var
  MainForm: TMainForm;

implementation

uses AboutUnit, ReplaceUnit, RunUnit, HintUnit,
     EnvironmentUnit, ExecuteOptionsUnit,
     FindUnit, GroupUnit, CMUnit, FavUnit, ViewUnit,
     SyntaxUnit, PropertiesUnit, RecentUnit;

{$R *.DFM}

procedure TMainForm.OnAppActivate (Sender : TObject);
begin
  CBtoPanel;
  FixColor;
end;

procedure TMainForm.OnAppDeactivate (Sender : TObject);
begin
  FixColor;
end;

function TMainForm.GetBackupName (const fName : TFileName) : TFileName;
//var fExt : TFileName;
begin
  if BackupExt = beBak then
    result := ChangeExt (fName, '.bak')
  else
    result := ExtractFilePath (fName) + '~' + ExtractFileName (fName);
  {
  if BackupExt = beBak then begin
    result := ChangeExt (fName, '.BAK');
    exit;
  end;

  fExt := ExtractFileExt (fName);
  if length (fExt) < 2 then
    result := ChangeExt (fName, '.~')
  else begin
    fExt[2] := '~';
    result := ChangeExt (fName, fExt);
  end;
  }
end;

function TMainForm.IsOptionsFile (const fName : TFileName; b : boolean) : boolean;
begin
  result := StrCmpi (fName, SourceDir + OptionsFileName);
  if result and b then
    ShowMsgDlg (EditorName + ' cannot open "' + OptionsFileName + '"', mtWarning);
end;


{function TMainForm.IsTooBig (fName : TFileName; b : boolean) : boolean;
begin
  result := FileTooBig (fName);
  if result and b then
    ShowMsgDlg (fName + ' is too big to be opened', mtWarning);
end;}

{procedure TMainForm.ShowUnregMsg;
begin
    ShowMessage ('This program is unregsitered shareware and should be used for evaluation purposes only.  By registering it you will recieve benefits like:' + cr +
      '1. This annoying message will not be displayed ever time you run this program.' + cr +
      '2. Your name will be in the About box' + cr +
      '3. I will answer questions you have about Code Edit' + cr +
      '4. You will be supporting independent programming' + pb +
      'If you decide to keep ' + EditorName + ', please send $5.00 (five-dollars) U.S. in cash or check to:' + pb +
      'Jimmy Reumuth' + cr +
      '406 Eldon Dr.' + cr +
      'Corpus Christi, Tx 78412' + cr +
      'United States of America' + pb +
      'Please include an e-mail address (which will NOT be used for any commercial purposes) to expedite your registration, and so I''ll be able to send you new versions of Code Edit at no cost to you.');
end;}

//Saves the selected text to file fName
procedure TMainForm.SelectionToFile (const fName : TFileName);
var FileVar : TextFile;
begin
  AssignFile (FileVar, fName);
  Rewrite (FileVar);
    write (FileVar, Edit.SelText);
  CloseFile (FileVar);
end;

{returns the main file of the current group, if FileName
 is in the open group, and a main file has been
 specified}
function TMainForm.GetMainFile : string;
begin
  if InCurGroup (FileName) and (MainFile[GroupOpen] >= 0) then
    result := groups[GroupOpen]^.Strings[MainFile[GroupOpen]]
  else
    result := FileName;
end;

procedure TMainForm.CreatePopUpMenu;
begin
  CopyMenuItem (OpenGroupPopItem, FileOpenGroupMnu);
  CopyMenuItem (AddToPopItem, FileAddMnu);
  CopyMenuItem (ClosePopItem, FileCloseMnu);
end;

procedure TMainForm.CBtoPanel;
begin
  if OptionsShowClipMnu.Checked then
    StatusBar1.Panels[PN_CLIP].Text := Clipboard.AsText;
end;

function TMainForm.IntToBackupExt (i : integer) : TBackupExt;
begin
  if i = 0 then
    result := beBak
  else
    result := beTilde;
end;

function TMainForm.CanAddTo (const fName : TFileName) : boolean;
begin
  result := not IsOptionsFile (fName, true);
  //if not result then exit;

  //result := not IsTooBig (fName, true);
end;

procedure TMainForm.SwapMemoAry (i : byte);
var
  s : string;
  m : boolean;
  SelStart, SelLength : cardinal;
begin
  s := FileName;
  FileName := Files[i]^.FileName;
  Files[i]^.FileName := s;

  SelLength := Edit.SelLength;
  SelStart := Edit.SelStart;
  m := Edit.Modified;

  s := Files[i]^.Text;
  Files[i]^.Text := Edit.Text;
  Edit.Text := s;

  Edit.SelStart := Files[i]^.SelStart;
  Edit.SelLength := Files[i]^.SelLength;
  Files[i]^.SelLength := SelLength;
  Files[i]^.SelStart := SelStart;

  ChangeModify (Files[i]^.Modified);
  Files[i]^.Modified := m;
  WriteModified;

  WriteCursPos;
  EnableCutCopy;

  m := Edit.ReadOnly;
  ChangeReadOnly (Files[i]^.ReadOnly);
  Files[i]^.ReadOnly := m;
end;

procedure TMainForm.NewMenuItem (i : byte; const fName : TFileName);
var MenuItem : TViewMenuItem;
begin
  MenuItem := TViewMenuItem.Create (ViewMnu);
  MenuItem.Tag := i;
  MenuItem.Caption := StrToCap (fName, i);

  if ViewMnu.Count mod MaxMenuRows = 0 then
    MenuItem.Break := mbBarBreak;

  ViewMnu.Add (MenuItem);
  EnableView;
end;

function TMainForm.EditToAry : boolean;
begin
  if (FileName = '') or (FilesOpen = 0) then begin
    result := false;
    exit;
  end;

  New (Files[FilesOpen]);
  Files[FilesOpen]^.Text := Edit.Text;
  Files[FilesOpen]^.Modified := Edit.Modified;
  Files[FilesOpen]^.SelStart := Edit.SelStart;
  Files[FilesOpen]^.SelLength := Edit.SelLength;
  Files[FilesOpen]^.FileName := FileName;
  Files[FilesOpen]^.ReadOnly := Edit.ReadOnly;

  NewMenuItem (FilesOpen, FileName);
  result := true;
end;

function TMainForm.AryToEdit : boolean;
begin
  if FilesOpen < 2 then begin
    result := false;
    exit;
  end;

  dec (FilesOpen);
  if WinNum = FilesOpen then WinNum := 1;

  {Changeing Edit.Text will call EditChange
   which calls WriteModified which would be set
   to false because of the assignment.}
  Edit.Text := Files[FilesOpen]^.Text;
  ChangeModify (Files[FilesOpen]^.Modified);
  Edit.SelStart := Files[FilesOpen]^.SelStart;
  Edit.SelLength := Files[FilesOpen]^.SelLength;
  ChangeReadOnly (Files[FilesOpen]^.ReadOnly);

  FileName := Files[FilesOpen]^.FileName;

  ViewMnu.remove (ViewMnu.Items[FilesOpen + DefViewNum - 1]);
  Dispose (Files[FilesOpen]);

  {
  OpenDialog1.InitialDir := ExtractFilePath (FileName);
  SaveDialog1.InitialDir := ExtractFilePath (FileName);
  }

  EnableView;
  WriteCursPos;
  result := true;
end;

procedure TMainForm.WriteModified;
var i : byte;
begin
  if not Edit.Visible then exit;
  EditUndoMnu.Enabled :=
    IntToBool (Edit.Perform (EM_CanUndo, 0, 0));
  UndoSpdBtn.Enabled := EditUndoMnu.Enabled;

  if Edit.Modified then begin
    StatusBar1.Panels[PN_MODIFIED].Text := 'Modified';
    FileSaveMnu.Enabled := true;
    //FileSaveMnu.Default := true;
    SaveSpdBtn.Enabled := true;
    SaveAllSpdBtn.Enabled := true;
    FileSaveAllMnu.Enabled := true;
  end else begin
    StatusBar1.Panels[PN_MODIFIED].Text := '';
    FileSaveMnu.Enabled := false;
    //FileOpenMnu.Default := true;
    SaveSpdBtn.Enabled := false;
    FileSaveAllMnu.Enabled := false;
    SaveAllSpdBtn.Enabled := false;
    if FilesOpen > 1 then
      for i := 1 to FilesOpen - 1 do
        if Files[i]^.Modified then begin
          FileSaveAllMnu.Enabled := true;
          SaveAllSpdBtn.Enabled := true;
          break;
        end;
  end;
end;

procedure TMainForm.ChangeModify (b : boolean);
begin
  if Edit.Modified = b then exit;
  Edit.Modified := b;
  WriteModified;
end;

procedure TMainForm.EnableMenus (b : boolean);
begin
  {Disables appropriate menus when all files
   are close and enables them again when at
   least one file is open}
  FileSaveMnu.Enabled := b;
  SaveSpdBtn.Enabled := b;
  FileSaveAllMnu.Enabled := b;
  SaveAllSpdBtn.Enabled := b;
  FileSaveAsMnu.Enabled := b;
  FileInsertMnu.Enabled := b;
  FilePrintMnu.Enabled := b;
  PrintSpdBtn.Enabled := b;
  FileBackupMnu.Enabled := b;
  FileUnbackupMnu.Enabled := b;
  FileReplaceMnu.Enabled := b;
  FileCloseMnu.Enabled := b;
  FileCloseCurrentFileMnu.Enabled := b;
  CloseSpdBtn.Enabled := b;
  FileCloseAllFilesMnu.Enabled := b;
  FileReloadMnu.Enabled := b;
  FileOperationsMnu.Enabled := b;
  FileAddMnu.Enabled := b;
  EditMnu.Enabled := b;
  CutSpdBtn.Enabled := b and EditCutMnu.Enabled;
  CopySpdBtn.Enabled := b and EditCopyMnu.Enabled;
  PasteSpdBtn.Enabled := b;
  SearchMnu.Enabled := b;
  FindSpdBtn.Enabled := b;
  SearchAgainSpdBtn.Enabled := b;
  ReplaceSpdBtn.Enabled := b;
  ExecuteCurrentFileMnu.Enabled := b and (ExeOpts.IndexOfSource (ExtractFileExt (FileName)) >= 0);
  ExecuteSpdBtn.Enabled := ExecuteCurrentFileMnu.Enabled;
  ViewMainFileMnu.Enabled := (GroupOpen > 0) and
    (MainFile[GroupOpen] >= 0);

  UndoSpdBtn.Enabled := b;
  OptionsPropertiesMnu.Enabled := b;

  if b then begin
    WriteModified;
    WriteCursPos;
    Insert := Insert;
  end else begin
    StatusBar1.Panels[PN_POS].Text := '';
    StatusBar1.Panels[PN_MODIFIED].Text := '';
    StatusBar1.Panels[PN_INSERT].Text := '';
  end;
end;

procedure TMainForm.ShowEdit;
begin
  Edit.Show;
  ActiveControl := Edit;
  EnableMenus (true);
end;

procedure TMainForm.NextUntitled;
begin
  inc (FilesOpen);
  inc (UntitledCount);

  FileName := ChangeExt ('Untitled' + IntToStr (UntitledCount), OpenDialog1.DefaultExt);
  WriteModified;
end;

procedure TMainForm.ChangeKeyMap (inKeyMap : TKeyMap);
begin
  KeyMap := inKeyMap;
  case KeyMap of
    kmWindows : begin
      FileSaveMnu.ShortCut := TextToShortCut ('Ctrl+S');
      FileOpenMnu.ShortCut := TextToShortCut ('Ctrl+O');
      SearchSearchAgainMnu.ShortCut := TextToShortCut ('F3');
      FileCloseCurrentFileMnu.ShortCut := TextToShortCut ('Ctrl+F4');
      FileExitMnu.ShortCut := TextToShortCut ('Alt+F4');
      EditUndoMnu.ShortCut := TextToShortCut ('Ctrl+Z');
      ViewSelectFileMnu.ShortCut := TextToShortCut ('F2');
    end;

    kmPascal : begin
      FileSaveMnu.ShortCut := TextToShortCut ('F2');
      FileOpenMnu.ShortCut := TextToShortCut ('F3');
      SearchSearchAgainMnu.ShortCut := TextToShortCut ('Ctrl+L');
      FileCloseCurrentFileMnu.ShortCut := TextToShortCut ('Alt+F3');
      FileExitMnu.ShortCut := TextToShortCut ('Alt+X');
      EditUndoMnu.ShortCut := TextToShortCut ('Alt+BkSp');
      ViewSelectFileMnu.ShortCut := TextToShortCut ('Alt+0');
    end;
  end;
end;

procedure TMainForm.AssignColorScheme (i : byte);
begin
  case i of
    0 : ColorScheme := csWindows;
    1 : ColorScheme := csPascal;
    2 : ColorScheme := csCustom;
  end;
  ChangeColor;
end;

procedure TMainForm.ChangeColor;
begin
  case ColorScheme of
    csWindows : begin
      Edit.Font.Color := clWindowText;
      Edit.Color := clWindow;
    end;

    csPascal : begin
      Edit.Font.Color := clYellow;
      Edit.Color := clNavy;
    end;

    csCustom : begin
      Edit.Font.Color := CustomFore;
      Edit.Color := CustomBack;
    end;
  end;
end;

procedure TMainForm.SetFileName (const s : TFileName);
begin
  FFileName := s;
  if FileName = '' then begin
    MainForm.Caption := EditorName;
    Edit.Hide;
    EnableMenus (false);
  end else begin
    if InCurGroup (FileName) then
      MainForm.Caption := EditorName +
        ' - [' + CapToStr (FileOpenGroupMnu.Items[GroupOpen - 1].Caption) + '] ' + FileName
    else
      MainForm.Caption := EditorName +
        ' - ' + FileName;

    ExecuteCurrentFileMnu.Enabled := ExeOpts.IndexOfSource (ExtractFileExt (FileName)) >= 0;
    ExecuteSpdBtn.Enabled := ExecuteCurrentFileMnu.Enabled;
  end;

  Application.Title := MainForm.Caption;
end;

function TMainForm.OpenFile (const fName : TFileName; b : boolean) : TCanOpen;
begin
  result := CanOpen (fName, b);

  if result <> coTrue then exit;

  if PersistentGroups and (GroupOpen > 0) and not InCurGroup (fName) then
    CloseAllFiles
  else if b then AddToGroup (fName, b);

  if Edit.Visible then
    EditToAry
  else
    ShowEdit;

  FileName := fName;
  OpenDialog1.InitialDir := ExtractFilePath (fName);
  inc (FilesOpen);

  try
    Edit.Lines.LoadFromFile (fName);
  except
    on Exception do begin
      CloseCurFileOnError;
      raise Exception.Create ('could not open file "' + fName + '"');
    end;
  end;

  Edit.SelStart := 0;
  ChangeReadOnly (IsReadOnly (fName));

  {RichEdits dont't change modified property
   to false after loading from file}
  ChangeModify (false);
end;

{this function opens fName directly into Files instead of
 into Edit; used at beginning if last files open are
 loaded so all files are not shown being opened and
 also used when a group is opened; b1 corresponds to b
 in OpenFile and if b2 = true then OpenFile is called
 instead of OpenFileBack}
function TMainForm.OpenFileBack (const fName : TFileName; b1, b2 : boolean) : TCanOpen;
begin
  //if b2 then use OpenFile instead of OpenFileBack
  if b2 then begin
    result := OpenFile (fName, b1);
    exit;
  end;

  result := CanOpen (fName, b1);

  if result <> coTrue then exit;

  //FilesOpen is inc in last line if not done here
  if FileName = '' then inc (FilesOpen);
  NewMenuItem (FilesOpen, fName);

  New (Files[FilesOpen]);
  Files[FilesOpen]^.Text := FileToStr (fName);
  Files[FilesOpen]^.Modified := false;
  Files[FilesOpen]^.FileName := fName;

  //these three are default value which may be overwritten
  Files[FilesOpen]^.ReadOnly := false;
  Files[FilesOpen]^.SelStart := 0;
  Files[FilesOpen]^.SelLength := 0;

  if FileName <> '' then inc (FilesOpen);
end;

procedure TMainForm.FileOpenMnuClick(Sender: TObject);
begin
  if FilesOpen = MaxFiles then begin
    ShowMsgDlg ('No more Files can be Opened!', mtWarning);
    exit;
  end;

  OpenDialog1.FilterIndex := GetFilterItemIndex (ExtractFileExt (FileName), OpenDialog1.Filter);

  if not OpenDialog1.execute then exit;

  if not FileExists (OpenDialog1.FileName) then begin
    if ofCreatePrompt in OpenDialog1.Options then begin
      {if execute and not FileExists then the
      user must have Yesed a Create Prompt}
      FileNewMnu.Click;
      FileName := OpenDialog1.FileName;
    end else
      ShowMsgDlg (OpenDialog1.FileName + ' does not exist', mtWarning);
  end else if OpenFile (OpenDialog1.FileName, true) <> coTrue then exit;

  //SaveDialog1.InitialDir := OpenDialog1.InitialDir;
  if ofReadOnly in OpenDialog1.Options then
    ChangeReadOnly (true);
end;

function TMainForm.CanOpen (const fName : TFileName; b : boolean) : TCanOpen;
begin
  if not FileExists (fName) then begin
    if b then ShowMsgDlg ('File "' + fName + '" cannot be found', mtWarning);
    result := coNotExists;
    exit;
  end;

  if not CanOpenOptions and IsOptionsFile (fName, b) then begin
    CanOpenOptions := false;
    result := coOptionsFile;
    exit;
  end;

  {if IsTooBig (fName, b) then begin
    result := coTooBig;
    exit;
  end;}

  if FilesOpen = MaxFiles then begin
    if b then ShowMsgDlg ('No more Files can be Opened!', mtWarning);
    result := coMaxFiles;
    exit;
  end;

  result := coTrue;
end;

procedure TMainForm.FileSaveMnuClick(Sender: TObject);
//var fName : TFileName;
begin
  //code to save my e-mail
  {fName := Edit.Lines[0];
  ReplaceAll (':', '-', fName);
  fName := 'A:\' + fName + '.txt';//don't replace : in A:\

  if FileExists (fName) then
    ShowMessage ('Not saving because file already exists')
  else begin
    FileName := fName;
    SaveCurFile;
  end;

  exit;}

  if IsUntitled (FileName) then
    FileSaveAsMnu.Click
  else
    SaveCurFile;
end;

procedure TMainForm.SaveCurFile;
begin
  if IsReadOnly (FileName) then begin
    raise EWriteError.Create ('This is a readonly file.  If you want to save this file, use a different name.');
    exit;
  end;

  Edit.Lines.SaveToFile (FileName);
  ChangeModify (false);
end;

procedure TMainForm.FileSaveAsMnuClick(Sender: TObject);
  {procedure UseFilterExt;
  var FilterExt : TFileName;
  begin
    with SaveDialog1 do begin
      FilterExt := GetFilterIndexExt (FilterIndex, Filter);

      if FilterExt <> '.*' then
        if ExtractFileExt (FileName) <> FilterExt then
          FileName := FileName + FilterExt;
    end;//with...
  end;}
begin
  if FileExists (FileName) then
    SaveDialog1.InitialDir := ExtractFilePath (FileName);

  SaveDialog1.FileName := ExtractFileName (ChangeExt (FileName, ''));

  {if FileExists (FileName) then
    SaveDialog1.InitialDir := ExtractFilePath (FileName);
  }
  SaveDialog1.FilterIndex := GetFilterItemIndex (ExtractFileExt (FileName), SaveDialog1.Filter);
  if not SaveDialog1.execute then exit;
  //UseFilterExt;apparently this is done automatically

  if FileExists (SaveDialog1.FileName) then begin
    if MessageDlg (SaveDialog1.FileName + ' exists.  Overwrite?', mtWarning, [mbYes, mbNo], 0) = mrNo then
      exit; //Modified still = true

    SaveDialog1.InitialDir := ExtractFilePath (FileName);
  end;

  AddToRecent (FileName, true);
  ChangeGroupFile (FileName, SaveDialog1.FileName);
  ChangeFavFile (FileName, SaveDialog1.FileName);
  FileName := SaveDialog1.FileName;
  SaveCurFile;
end;

procedure TMainForm.SearchFindMnuClick(Sender: TObject);
begin
  FindForm.ShowModal;
end;

procedure TMainForm.SearchReplaceMnuClick(Sender: TObject);
begin
  ReplaceForm.ShowModal;
end;

procedure TMainForm.FilePrintMnuClick(Sender: TObject);
var FileVar : TextFile;
begin
  Printer.Canvas.Font := Edit.Font;
  Printer.Canvas.Font.Color := clBlack;
  Printer.Title := FileName;
  //PrintDlg.MaxPage := Printer.PageHeight div abs (Edit.Font.Height);
  //PrintDlg.ToPage := PrintDlg.MaxPage;
  If Edit.SelLength = 0 then
    PrintDlg.Options := PrintDlg.Options - [poSelection]
  else begin
    PrintDlg.Options := PrintDlg.Options + [poSelection];
    PrintDlg.PrintRange := prSelection;
  end;

  if not PrintDlg.Execute then exit;
  //Edit.Print (FileName);

  AssignPrn (FileVar);
  ReWrite (FileVar);

  if PrintDlg.PrintRange = prSelection then
     WriteLn (FileVar, Edit.SelText)
  else
     WriteLn (FileVar, Edit.Text);

  {Copies := Printer.Copies;
  Printer.Copies := 0;

  if (Copies = 1) or PrintDlg.Collate then
    for i := 1 to Copies do
      if (PrintDlg.PrintRange = prSelection)
      and (MainForm.Edit.SelLength > 0) then
        WriteLn (FileVar, Edit.SelText)
      else
        WriteLn (FileVar, Edit.Text)

  else
    with MainForm.Edit do begin
      if (PrintDlg.PrintRange = prSelection)
      and (MainForm.Edit.SelLength > 0) then begin
        StartCount := Perform (EM_LineFromChar, -1, 0);
        EndLine := Perform (EM_LineFromChar, SelStart + SelLength, 0);
      end else begin
        EndCount := 0;
        EndLine := Lines.Count;
      end;

      while (EndCount < EndLine) do begin
        StartCount := EndCount;
        LastPageNum := Printer.PageNumber;

        while (LastPageNum = Printer.PageNumber)
        and (EndCount < EndLine) do begin
          WriteLn (FileVar, Lines[EndCount]);
          inc (EndCount);
        end;
        if LastPageNum = Printer.PageNumber then
          Printer.NewPage;
   }
        {LastPageNum is being used as an index
         for the for loop here to keep another
         variable from having to be declared}
   {     for LastPageNum := 1 to Copies - 1 do
          for i := StartCount to EndCount - 1 do
            WriteLn (FileVar, Lines[i]);

      end;
    end;//with
    }
  CloseFile (FileVar);
end;

procedure TMainForm.OptionsFontMnuClick(Sender: TObject);
// var hSS, hSL : cardinal;
begin
  FontDialog1.Font := Edit.Font;
  if FontDialog1.Execute then begin
    if FontDialog1.Font.Color <> Edit.Font.Color then begin
      ColorScheme := csCustom;
      CustomFore := FontDialog1.Font.Color;
      CustomBack := Edit.Color;
    end;

    {with Edit do begin
      hSS := SelStart;
      hSL := SelLength;
      SelectAll;
      SelAttributes.Assign (FontDialog1.Font);
      SelStart := hSS;
      SelLength := hSL;
    end;}
    Edit.Font := FontDialog1.Font;
  end;
end;

procedure TMainForm.OptionsEnvironmentMnuClick(Sender: TObject);
begin
  EnvironmentForm.ShowModal;
end;

procedure TMainForm.EnableView;
begin
  if ViewMnu.Count > DefViewNum then begin
    ViewMnu.Enabled := true;
    PopupMenu1.Items.Items[0].Enabled := true;
    PopupMenu1.Items.Items[1].Enabled := true;
    PreviousSpdBtn.Enabled := true;
    NextSpdBtn.Enabled := true;
    ViewSpdBtn.Enabled := true;
  end else begin
    ViewMnu.Enabled := false;
    PopupMenu1.Items.Items[0].Enabled := false;
    PopupMenu1.Items.Items[1].Enabled := false;
    PreviousSpdBtn.Enabled := false;
    NextSpdBtn.Enabled := false;
    ViewSpdBtn.Enabled := false;
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  FileVar : TextFile;
  i : integer;
  InStr : string;
  i2, j2, j : cardinal;
  RunMenuItem : TRunMenuItem;
  RecentMenuItem : TRecentMenuItem;
  GroupMenuItem : TGroupMenuItem;
  FavMenuItem : TFavMenuItem;
  ExeOpt : TExeOpt;
begin
  Application.OnActivate := OnAppActivate;
  Application.OnDeactivate := OnAppDeactivate;
  WinNum := 1;
  SourceDir := ExtractFilePath (Application.ExeName);
  DefViewNum := ViewMnu.Count;
  FilesOpen := 0;
  CanOpenOptions := false;
  ExeOpts.Create;
  //KeyWords.Init;
  //Application.HintShortPause := 0;

  if not FileExists (SourceDir + OptionsFileName) then begin
    RunMnu.Enabled := RunMnu.Count > 0;
    EnableView;
    EnableCutCopy;
    {WriteCursPos is not called if Mouse is not
     on Code Edit, which calls OnMouseMove,
     when it starts}
    WriteCursPos;

    OpenDialog1.Filter := DefaultFilters;
    SaveDialog1.Filter := DefaultFilters;

    GroupOpen := 0;
    if not OpenParam then
      if OpenFile (SourceDir + ReadMeFileName, true) <> coTrue then
        FileName := '';

    SetScrollBars;
    Insert := true;
    ConfirmPrompt := true;

    CreatePopUpMenu;
    //Edit.MaxLength := High (LongInt) - 2;
    MaxRecentNum := MaxMenuRows;

    exit;
  end;

  AssignFile (FileVar, SourceDir + OptionsFileName);
  ReSet (FileVar);
    ReadLn (FileVar, CustomBack);
    ReadLn (FileVar, CustomFore);
    ReadLn (FileVar, i);
    Edit.SelectAll;
    AssignColorScheme (i);
    {for some wierd reason, just assigning Font.Color
     won't change Edit's appearance}
    Edit.SelAttributes.Color := Edit.Font.Color;

    ReadLn (FileVar, i);
    case i of
      Ord (kmWindows) : ChangeKeyMap (kmWindows);
      Ord (kmPascal) : ChangeKeyMap (kmPascal);
    end;

    ReadLn (FileVar, i);
    for j := 1 to i do begin
      with ExeOpt do begin
        ReadLn (FileVar, SourceExt);
        ReadLn (FileVar, ExeExt);
        ReadLn (FileVar, i2);
        ParamsPrompt := IntToBool (i2);
        ReadLn (FileVar, i2);
        cd := IntToBool (i2);
        ReadLn (FileVar, SaveOrBackupIndex);
      end;
      ExeOpts.Add (ExeOpt);
    end;

    ReadLn (FileVar, i);
    ExecuteCurrentFileMnu.ShortCut := i;

    ReadLn (FileVar, i);
    PersistentGroups := IntToBool (i);

    ReadLn (FileVar, i);
    ConfirmPrompt := IntToBool (i);

    ReadLn (FileVar, GroupOpen);
    with FileOpenGroupMnu do begin
      ReadLn (FileVar, j);

      if j > 0 then
        for i := 0 to j - 1 do begin
          GroupMenuItem := TGroupMenuItem.Create (FileOpenGroupMnu);
          ReadLn (FileVar, InStr);
          GroupMenuItem.Caption := InStr;
          Add (GroupMenuItem);

          new (groups[i + 1]);
          groups[i + 1]^ := TStringList.Create;

          ReadLn (FileVar, j2);
          for i2 := 0 to j2 - 1 do begin
            ReadLn (FileVar, InStr);
            groups[i + 1]^.Add (InStr);
          end;

          ReadLn (FileVar, MainFile[i + 1]);
        end;//for i...
    end;//with File...

    ReadLn (FileVar, StartWith);
    if StartWith <> swLastFile then GroupOpen := 0;

    case StartWith of
      swLastFile : begin
        FileName := '';
        ReadLn (FileVar, i);
        while (i > 0) do begin
          ReadLn (FileVar, InStr);

          i2 := Ord (Edit.Visible);
          if OpenFileBack (InStr, false, not Edit.Visible) = coTrue then begin
            if i2 = 0 then begin
              //if Edit just became visible
              ReadLn (FileVar, j);
              ChangeReadOnly (IntToBool (j));

              ReadLn (FileVar, j);
              Edit.SelStart := j;

              ReadLn (FileVar, j);
              Edit.SelLength := j;
            end else begin
              ReadLn (FileVar, j);
              Files[FilesOpen - 1]^.ReadOnly := IntToBool (j);

              ReadLn (FileVar, j);
              Files[FilesOpen - 1]^.SelStart := j;

              ReadLn (FileVar, j);
              Files[FilesOpen - 1]^.SelLength := j;
            end;
          end else begin
            ReadLn (FileVar);
            ReadLn (FileVar);
            ReadLn (FileVar);
          end;//if...
          dec (i);
        end;//while...

        OpenParam;
      end;//case swLastOpen

      swNewFile : if not OpenParam then FileNewMnu.Click;
      swNoOpen : if not OpenParam then FileName := '';
    end;//case
    EnableView;

    ReadLn (FileVar, InStr);
    Edit.Font.Name := InStr;
    ReadLn (FileVar, i);
    Edit.Font.Size := i;

    ReadLn (FileVar, i);
    if i = 1 then Edit.Font.Style := Edit.Font.Style + [fsBold];
    ReadLn (FileVar, i);
    if i = 1 then Edit.Font.Style := Edit.Font.Style + [fsItalic];
    ReadLn (FileVar, i);
    if i = 1 then Edit.Font.Style := Edit.Font.Style + [fsUnderLine];
    ReadLn (FileVar, i);
    if i = 1 then Edit.Font.Style := Edit.Font.Style + [fsStrikeOut];

    ReadLn (FileVar, i);
    Timer1.Enabled := IntToBool (i);
    ReadLn (FileVar, i);
    Timer1.Interval := i;

    ReadLn (FileVar, i);
    if i = 0 then begin
      WindowState := wsNormal;
      ReadLn (FileVar, i); Top := i;
      ReadLn (FileVar, i); Left := i;
      ReadLn (FileVar, i); Height := i;
      ReadLn (FileVar, i); Width := i;
    end else
      WindowState := wsMaximized;

    ReadLn (FileVar, i);
    OptionsShowClipMnu.Checked := IntToBool (i);

    ReadLn (FileVar, i);
    OptionsScrollBarsMnu.Checked := IntToBool (i);

    ReadLn (FileVar, i);
    SetWrap (IntToBool (i));

    ReadLn (FileVar, i);
    if not IntToBool (i) then begin
      {Edit's insert apparaently defaults to true, so
       assigning true to insert puts Insert in phase w/
       Edit's insert}
      FInsert := true;
      {this will call KeyDown which will call Insert :=,
       but it also changes Edit's insert}
      Edit.Perform (WM_KEYDOWN, VK_INSERT, 0);
    end else Insert := true;

    ReadLn (FileVar, i);
    ShowToolBar (IntToBool (i));

    ReadLn (FileVar, i);
    ShowStatusBar (IntToBool (i));

    ReadLn (FileVar, NumOfRecs);
    RunMnu.Enabled := NumOfRecs > 0;
    if NumOfRecs > 0 then
      for j := 1 to NumOfRecs do begin
        RunMenuItem := TRunMenuItem.Create (RunMnu);
        New (Progs[j]);
        ReadLn (FileVar, Progs[j]^.Prog);
        ReadLn (FileVar, Progs[j]^.Params);
        ReadLn (FileVar, i);
        Progs[j]^.SaveOrBackupIndex := i;
        ReadLn (FileVar, InStr);
        RunMenuItem.Caption := InStr;
        ReadLn (FileVar, i);
        RunMenuItem.ShortCut := i;
        RunMenuItem.Tag := j;
        RunMnu.Add (RunMenuItem);

        Progs[j]^.BatFile := TStringList.Create;
        ReadLn (FileVar, i);
        while (i > 0) do begin
          ReadLn (FileVar, InStr);
          Progs[j]^.BatFile.Insert (Progs[j]^.BatFile.Count, InStr);
          dec (i);
        end;
      end;

    //if not Registered then ShowUnregMsg;

    ReadLn (FileVar, i);
    Application.ShowHint := IntToBool (i);
    ReadLn (FileVar, i);
    Application.HintPause := i;
    ReadLn (FileVar, i);
    Application.HintHidePause := i;
    ReadLn (FileVar, i);
    Application.HintColor := i;

    ReadLn (FileVar, j);
    if j > 0 then
      for i := 0 to j - 1 do begin
        RecentMenuItem := TRecentMenuItem.Create (FileRecentMnu);
        ReadLn (FileVar, InStr);
        RecentMenuItem.Caption := InStr;
        FileRecentMnu.Add (RecentMenuItem);
      end;
    ReadLn (FileVar, j);
    MaxRecentNum := j;

    ReadLn (FileVar, j);
    if j > 0 then
      for i := 0 to j - 1 do begin
        FavMenuItem := TFavMenuItem.Create (FileFavoritesMnu);
        ReadLn (FileVar, InStr);
        FavMenuItem.Caption := InStr;
        FileFavoritesMnu.Add (FavMenuItem);
      end;

    ReadLn (FileVar, i);
    BackupExt := IntToBackupExt (i);

    ReadLn (FileVar, InStr);
    SaveDialog1.DefaultExt := InStr;
    OpenDialog1.DefaultExt := InStr;

    ReadLn (FileVar, InStr);
    SaveDialog1.Filter := InStr;
    OpenDialog1.Filter := SaveDialog1.Filter;

    ReadLn (FileVar, InStr);
    SaveDialog1.InitialDir := InStr;
    ReadLn (FileVar, InStr);
    OpenDialog1.InitialDir := InStr;

    ReadLn (FileVar, i);
    ShowPathsChecked := IntToBool (i);
  CloseFile (FileVar);

  //Edit.MaxLength := High (LongInt) - 2;
  CreatePopUpMenu;
end;

procedure TMainForm.SaveOptions;
var
  FileVar : TextFile;
  i, j : byte;
begin
  //ReadOnlyFile (SourceDir + OptionsFileName, false);
  if IsOptionsFile (FileName, false) then CloseCurFile;

  AssignFile (FileVar, SourceDir + OptionsFileName);
  ReWrite (FileVar);
    WriteLn (FileVar, CustomBack);
    WriteLn (FileVar, CustomFore);
    WriteLn (FileVar, Ord (ColorScheme));
    WriteLn (FileVar, Ord (KeyMap));

    WriteLn (FileVar, ExeOpts.GetCount);
    if ExeOpts.GetCount > 0 then
      for i := 0 to ExeOpts.GetCount - 1 do
        with ExeOpts.Items[i]^ do begin
          WriteLn (FileVar, SourceExt);
          WriteLn (FileVar, ExeExt);
          WriteLn (FileVar, Ord (ParamsPrompt));
          WriteLn (FileVar, Ord (cd));
          WriteLn (FileVar, SaveOrBackupIndex);
        end;//with...

    WriteLn (FileVar, ExecuteCurrentFileMnu.ShortCut);

    WriteLn (FileVar, Ord (PersistentGroups));
    WriteLn (FileVar, Ord (ConfirmPrompt));

    WriteLn (FileVar, GroupOpen);
    with FileOpenGroupMnu do begin
      WriteLn (FileVar, Count);

      if Count > 0 then
        for i := 0 to Count - 1 do begin
          WriteLn (FileVar, Items[i].Caption);

          with groups[i + 1]^ do begin
            WriteLn (FileVar, Count);
            if Count > 0 then
              for j := 0 to Count - 1 do
                WriteLn (FileVar, Strings[j]);
          end;//with groups...

          WriteLn (FileVar, MainFile[i + 1]);
        end;//for...
    end;//with File...

    WriteLn (FileVar, StartWith);
    if StartWith = swLastFile then begin
      WriteLn (FileVar, FilesOpen);
      if FilesOpen > 0 then begin
        WriteLn (FileVar, FileName);
        WriteLn (FileVar, Ord (Edit.ReadOnly));
        WriteLn (FileVar, Edit.SelStart);
        WriteLn (FileVar, Edit.SelLength);

        if FilesOpen > 1 then
          for i := 1 to FilesOpen - 1 do begin
            WriteLn (FileVar, Files[i]^.FileName);
            WriteLn (FileVar, Ord (Files[i]^.ReadOnly));
            WriteLn (FileVar, Files[i]^.SelStart);
            WriteLn (FileVar, Files[i]^.SelLength);
          end;
      end;//if FilesOepn...
    end else begin//if StartWith...
      {if not swLastFile then all files are
       closed and should be added to recent}
      if FilesOpen > 0 then begin
        AddToRecent (FileName, true);
        if FilesOpen > 1 then
          for i := 1 to FilesOpen - 1 do
            AddToRecent (Files[i]^.FileName, true);
      end;
    end;

    WriteLn (FileVar, Edit.Font.Name);
    WriteLn (FileVar, Edit.Font.Size);
    WriteLn (FileVar, ord (fsBold in Edit.Font.Style));
    WriteLn (FileVar, ord (fsItalic in Edit.Font.Style));
    WriteLn (FileVar, ord (fsUnderLine in Edit.Font.Style));
    WriteLn (FileVar, ord (fsStrikeOut in Edit.Font.Style));

    WriteLn (FileVar, Ord (Timer1.Enabled));
    WriteLn (FileVar, Timer1.Interval);

    WriteLn (FileVar, ord (WindowState));
    if WindowState = wsNormal then begin
      WriteLn (FileVar, Top);
      WriteLn (FileVar, Left);
      WriteLn (FileVar, Height);
      WriteLn (FileVar, Width);
    end;

    WriteLn (FileVar, Ord (OptionsShowClipMnu.Checked));
    WriteLn (FileVar, Ord (OptionsScrollBarsMnu.Checked));
    WriteLn (FileVar, Ord (WrapMnu.Checked));
    WriteLn (FileVar, Ord (Insert));
    WriteLn (FileVar, Ord (ToolBar.Visible));
    WriteLn (FileVar, Ord (OptionsStatusMnu.Checked));

    WriteLn (FileVar, NumOfRecs);
    if NumOfRecs > 0 then
      for i := 1 to NumOfRecs do begin
        WriteLn (FileVar, Progs[i]^.Prog);
        WriteLn (FileVar, Progs[i]^.Params);
        WriteLn (FileVar, Progs[i]^.SaveOrBackupIndex);
        WriteLn (FileVar, RunMnu.Items[i - 1].Caption);
        WriteLn (FileVar, RunMnu.Items[i - 1].ShortCut);

        WriteLn (FileVar, Progs[i]^.BatFile.Count);
        if Progs[i]^.BatFile.Count > 0 then
          for j := 0 to Progs[i]^.BatFile.Count - 1 do
            WriteLn (FileVar, Progs[i]^.BatFile[j]);
      end;

    WriteLn (FileVar, Ord (Application.ShowHint));
    WriteLn (FileVar, Application.HintPause);
    WriteLn (FileVar, Application.HintHidePause);
    WriteLn (FileVar, Application.HintColor);

    with FileRecentMnu do begin
      WriteLn (FileVar, Count);
      if Count > 0 then
        for i := 0 to Count - 1 do
          WriteLn (FileVar, Items[i].Caption);
    end;//with...
    WriteLn (FileVar, MaxRecentNum);

    with FileFavoritesMnu do begin
      WriteLn (FileVar, Count);
      if Count > 0 then
        for i := 0 to Count - 1 do
          WriteLn (FileVar, Items[i].Caption);
    end;//with...

    WriteLn (FileVar, Ord (BackupExt));

    {DefaultExt and Filter are same in Open
     and Save Dialogs}
    WriteLn (FileVar, OpenDialog1.DefaultExt);
    WriteLn (FileVar, SaveDialog1.Filter);
    WriteLn (FileVar, SaveDialog1.InitialDir);
    WriteLn (FileVar, OpenDialog1.InitialDir);

    WriteLn (FileVar, Ord (ViewForm.ShowPathsCB.Checked));
  CloseFile (FileVar);
  //ReadOnlyFile (SourceDir + OptionsFileName, true);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
var i : byte;
begin
  DelTempBatFile;

  if FilesOpen > 1 then
    {The for loop uses a downto because higher
     items must be removed from a menu before
     lower ones.}
    for i := FilesOpen - 1 downto 1 do
      Dispose (Files[i]);

  if NumOfRecs > 0 then
    for i := 1 to NumOfRecs do
      Dispose (Progs[i]);

  if FileOpenGroupMnu.Count > 0 then
    for i := 1 to FileOpenGroupMnu.Count do
      Dispose (groups[i]);

  ExeOpts.Free;
  //KeyWords.Free;
end;

function TMainForm.CloseCurFile : boolean;
begin
  if not Edit.Visible then begin
    result := false;
    exit;
  end;

  if Edit.Modified then
    if SaveChanges (0) = mrCancel then begin
      result := false;
      exit;
    end;

  AddToRecent (FileName, true);

  if FilesOpen = 1 then begin
    MainForm.Edit.Clear;
    MainForm.FileName := '';
    //FileName := '' hides Edit
    dec (FilesOpen);
    //FileOpenMnu.Default := true;
  end else
    AryToEdit;

  result := true;
end;

{procedure to CloseCurFile if an error occurs while
 opening it}
procedure TMainForm.CloseCurFileOnError;
begin
  if FilesOpen = 1 then begin
    MainForm.Edit.Clear;
    MainForm.FileName := '';
    //FileName := '' hides Edit
    dec (FilesOpen);
    //FileOpenMnu.Default := true;
  end else
    AryToEdit;
end;

procedure TMainForm.FileNewMnuClick(Sender: TObject);
begin
  if FilesOpen = MaxFiles then begin
    ShowMsgDlg ('No more Files can be Opened!', mtWarning);
    exit;
  end;

  if Edit.Visible then begin
    if FilesOpen > 0 then EditToAry;
  end else
    ShowEdit;

  ChangeReadOnly (false);
  NextUntitled;
  //NextUntitled contains inc (FilesOpen);
  Edit.Clear;
  ChangeModify (false);
end;

procedure TMainForm.FileExitMnuClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.EditSelectAllMnuClick(Sender: TObject);
begin
  Edit.SelectAll;
end;

procedure TMainForm.EditCutMnuClick(Sender: TObject);
begin
  Edit.CutToClipboard;
  EnableCutCopy;
  CBtoPanel;
end;

procedure TMainForm.EditCopyMnuClick(Sender: TObject);
begin
  Edit.CopyToClipboard;
  CBtoPanel;
end;

procedure TMainForm.EditPasteMnuClick(Sender: TObject);
begin
  Edit.PasteFromClipboard;
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
  If MainForm.Active then begin
    if Timer1.Interval = 1000 then
      Timer1.Interval := Timer1.Tag;

    FileSaveAllMnu.Click;
  end else if Timer1.Interval <> 1000 then begin
    Timer1.Tag := Timer1.Interval;
    Timer1.Interval := 1000;
  end;
end;

procedure TMainForm.EditChange(Sender: TObject);
//var OldRE : TRichEdit;
begin
{
  OldRE := TRichEdit.Create (MainForm);
  OldRE := TRichEdit (Sender);
  if ColorCode (OldRE, 0) then
    Edit := OldRE;
  OldRE.Destroy;
}
end;

procedure TMainForm.SearchSearchAgainMnuClick(Sender: TObject);
begin
  if FindText = '' then
    FindForm.ShowModal
  else begin
    FindText := FindForm.FindEdit.Text;
    if not Search (FindForm.Options) then
      ShowFoundDlg (true);

  end;
end;

function TMainForm.Search (const Options : TSearchTypes): boolean;
var
  i : integer;
  {Position,} len : cardinal;
  //_FindText, SearchText : string;
begin
  len := length (FindText);

  {if frDown in Options then begin
    SearchText := copy (Edit.Text, FindPosition, EndFindPosition - FindPosition + 1);
    _FindText := FindText;
  end else begin
    SearchText := StrRev (copy (Edit.Text, FindPosition, EndFindPosition - FindPosition + 1));
    _FindText := StrRev (FindText);
  end;}

  {if not (frMatchCase in Options) then begin
    _FindText := LowerCase (_FindText);
    SearchText := LowerCase (SearchText);
  end;}

  {FindPosition is the character at the the
   start of the characters that are searched
   through rather than the character before,
   thus the need for a minus one in i's
   assignment.}

  //Position := pos (_FindText, SearchText);
  i := Edit.FindText (FindText, FindPosition, EndFindPosition - FindPosition + 1, Options);
  {if frDown in Options then
    i := FindPosition + Position - 1
  else
    i := EndFindPosition - Position - len + 2;
  }
  {if (i >= FindPosition) and
     (i <= EndFindPosition - len + 1) then begin
  }
  result := i >= 0;
  if not result then exit;

  //if i >= 0 then begin
    //if frDown in Options then
      FindPosition := i + len;
    //else
      //EndFindPosition := i - 1;

    {if frWholeWord in Options then
      if (Edit.Text[i - 1] in ['a'..'z','A'..'Z','0'..'9'])
         or (Edit.Text[i + len] in ['a'..'z','A'..'Z','0'..'9']) then begin
        result := Search (Options);
        exit;
      end;}

    {0 indicates 1st character for SelStart,
     but i starts counting on one, hence the
     - 1 in the next statement.}
    Edit.Perform (EM_SETSEL, i, i + len);
    {Edit.SelStart := i - 1;
    Edit.SelLength := len;}
    WriteCursPos;
    //result := true;
    //FoundOne := true;
  //end else begin
    //result := false;
    {if not FoundOne then
      ShowMsgDlg ('Search String "' + FindText + '" not found', mtInformation)
    else
      if frReplaceAll in Options then
        ShowMsgDlg ('Replacing "' + FindText + '" Completed!', mtInformation)
      else
        ShowMsgDlg ('No More Matches for "' + FindText + '" Found', mtInformation);
    }
  //end;// if >= FindPosition...
end;

procedure TMainForm.FormResize(Sender: TObject);
begin
  {Makes UpDown1.Position at least 0; here in
   case someone uses UpDown1 then resizes
   MainForm where UpDown1 is still visible;
   0 is the maximum value of UpDown1.Position}
  while UpDown1.Position < 0 do begin
    UpDown1.Position := UpDown1.Position + 1;
    UpDown1.OnClick (Sender, btNext);
  end;

  {Change height and width of Memo and Panel
   1 based upon StatusBar1 because it
   automatically resizes and moves when
   MainForm is resized}
{  Edit.Height := StatusBar1.Top - Edit.Top;
  Panel1.Width := StatusBar1.Width;
  Edit.Width := StatusBar1.Width;
}
  {Make UpDown1 visible if MainForm is resized
   so that the last Speed Button, HelpSpdBtn,
   is not totally visible}
  UpDown1.Visible :=
    ToolBar.Width < HelpSpdBtn.Left
    + HelpSpdBtn.Width;

  {Put UpDown1 in right corner of Panel1}
  UpDown1.Left := ToolBar.Width - UpDown1.Width
                  - 7;

  {Min should = - Number of clicks needed to
   move HelpSpdBtn completely to the left of
   UpDown1 by moving the width of a Speed
   Button per click. The 1st 3 variables in ()
   repRecent the total maximum distance
   distance buttons will have to be able to
   move; it's div by the distance moved per
   click; - 1 because the number of click
   should be rounded up, the 1 and a div
   which rounds down gives the answer as if it
   were a division rounded up w/o the 1; 1 is
   - because UpDown1.Min is -}
  UpDown1.Min :=
    (UpDown1.Left - HelpSpdBtn.Left -
    HelpSpdBtn.Width)
    div ToolBar.Controls[0].Width - 1;
    {(UpDown1.Left - Panel1.Controls[0].Left
    - 28) div Panel1.Controls[0].Width
    - Panel1.ControlCount + 1;}
end;

function TMainForm.SaveChanges (i : byte) : word;
begin
  if i >= FilesOpen then begin
    result := 0;
    exit;
  end;

  if ((i = 0) and (not Edit.Modified)) or ((i > 0) and (not Files[i]^.Modified)) then begin
    result := mrYes;
    exit;
  end;

  if i > 0 then SwapMemoAry (i);
  result :=  MessageDlg ('Save Changes to ' + FileName + '?', mtConfirmation, mbYesNoCancel, 0);

  try
    if result = mrYes then FileSaveMnu.Click;
  except
    on WriteErr : EWriteError do begin
      ShowMsgDlg (WriteErr.Message, mtError);
      result := mrCancel;
    end;
  end;

  if i > 0 then SwapMemoAry (i);
end;

procedure TMainForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
var i : byte;
begin
  if FilesOpen > 0 then
    for i := 0 to FilesOpen - 1 do
      if ((i = 0) and (Edit.Modified)) or ((i > 0) and (Files[i]^.Modified)) then
        case SaveChanges (i) of
          mrYes : begin
            if ((i = 0) and (Edit.Modified)) or ((i > 0) and (Files[i]^.Modified)) then
              if MessageDlg ('Still Wish to Exit Without Saving Chantges?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then begin
                Action := caNone;
                exit;
              end;
          end;//mrYes : begin

          mrCancel : begin
            Action := caNone;
            exit;
          end;
        end;

  Action := caFree;
  SaveOptions;
end;

procedure TMainForm.ReplaceDialog1Show(Sender: TObject);
begin
  FindPosition := 1;
  EndFindPosition := length (Edit.Text);
end;

procedure TMainForm.FileSaveAllMnuClick(Sender: TObject);
var i : byte;
begin
  FileSaveMnu.Click;

  for i := 1 to FilesOpen - 1 do
    if IsUntitled (Files[i]^.FileName) then begin
      SwapMemoAry (i);
      FileSaveAsMnu.Click;
      if Edit.Modified then
        if MessageDlg ('Do you wish to continue saving files?',
                       mtConfirmation, [mbYes, mbNo], 0) = mrNo then begin
          SwapMemoAry (i);
          exit;
        end;

      SwapMemoAry (i);
    end else
      Files[i]^.Save;

  WriteModified;
end;

procedure TMainForm.EditDeleteMnuClick(Sender: TObject);
begin
  Edit.ClearSelection;
  {if Edit.SelText = '' then
    ChangeSelState (ssBlank)
  else
    ChangeSelState (ssCopied);}
end;

procedure TMainForm.ViewNextMnuClick(Sender: TObject);
begin
  if not NextSpdBtn.Enabled then exit;

  ViewMnu.Items[WinNum + DefViewNum - 1].Click;

  if WinNum = FilesOpen - 1 then
    WinNum := 0;
  inc (WinNum);
end;

procedure TMainForm.ViewPreviousMnuClick(Sender: TObject);
begin
  if not PreviousSpdBtn.Enabled then exit;

  if WinNum = 1 then
    WinNum := FilesOpen;
  dec (WinNum);

  ViewMnu.Items[WinNum + DefViewNum - 1].Click;
end;

procedure TMainForm.SearchGotoLineNumberMnuClick(Sender: TObject);
var
  LineCount, LineNum : word;
  LineNumStr : string;
begin
  if not InputQuery ('Goto', 'Input line number to goto', LineNumStr) then exit;

  LineNum := Int (LineNumStr);
  if LineNum = 0 then begin
    ShowMsgDlg ('Inavlid Line Number', mtWarning);
    exit;
  end;

  LineCount := Edit.Perform (EM_GetLineCount, 0, 0);

  if LineNum > LineCount then
    LineNum := LineCount;

  Edit.SelStart :=
    Edit.Perform (EM_LineIndex, LineNum - 1, 0);

  Edit.Perform (EM_ScrollCaret, 0, 0);
end;

procedure TMainForm.WrapMnuClick(Sender: TObject);
begin
  SetWrap (not WrapMnu.Checked);
end;

procedure TMainForm.SetWrap (b : boolean);
var SelStart, SelLength : word;
begin
  SelStart := Edit.SelStart;
  SelLength := Edit.SelLength;

  WrapMnu.Checked := b;
  Edit.WordWrap := b;

  SetScrollBars;

  Edit.SelStart := SelStart;
  Edit.SelLength := SelLength;

  WriteCursPos;
end;

procedure TMainForm.SetScrollBars;
var SelStart, SelLength : Integer;
begin
  SelStart := Edit.SelStart;
  SelLength := Edit.SelLength;

  if OptionsScrollBarsMnu.Checked then
    if Edit.WordWrap then
      Edit.ScrollBars := ssVertical
    else
      Edit.ScrollBars := ssBoth
  else
    Edit.ScrollBars := ssNone;

  Edit.SelStart := SelStart;
  Edit.SelLength := SelLength;
end;

procedure TMainForm.SetInsert (b : boolean);
begin
  FInsert := b;
  if not Edit.Visible then exit;
  if Insert then
    StatusBar1.Panels[PN_INSERT].Text := 'Insert'
  else
    StatusBar1.Panels[PN_INSERT].Text := 'Overwright';
end;

procedure TMainForm.EditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  EnableCutCopy;
  WriteCursPos;

  if LastSelLength <> Edit.SelLength then begin
    LastSelLength := Edit.SelLength;
    LastStart := Edit.SelStart;
  end;

  DoCBtoPanel := ((ssCtrl in Shift) and (Key = VK_INSERT))
     or ((ssShift in Shift) and (Key = VK_DELETE));

  if Key = VK_INSERT then
    if Shift = [] then
      Insert := not Insert;

  if (Key = VK_F10) and (ssShift in Shift) then
    PopupMenu1.Popup (Left + Edit.Left + 6, Top + Edit.Top + ToolBar.Height + 11);
end;

procedure TMainForm.EditMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  EnableCutCopy;
  WriteCursPos;
end;

procedure TMainForm.EditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if DoCBToPanel then CBtoPanel;

  WriteModified;
  EnableCutCopy;
  WriteCursPos;
end;

procedure TMainForm.WriteCursPos;
var y, pos : cardinal;
begin
  if not Edit.Visible then exit;
  if Edit.SelStart = LastStart then
    pos := Edit.SelStart + Edit.SelLength
  else
    pos := Edit.SelStart;

  y := Edit.Perform (EM_LINEFROMCHAR, pos, 0);

  StatusBar1.Panels[PN_POS].Text := IntToStr (y + 1)
    + ': ' + IntToStr (pos - Edit.Perform (EM_LINEINDEX, y, 0) + 1);
end;

procedure TMainForm.EnableCutCopy;
begin
  if Edit.SelText <> '' then begin
    EditCutMnu.Enabled := true;
    EditCopyMnu.Enabled := true;
    EditDeleteMnu.Enabled := true;
    CutSpdBtn.Enabled := true;
    CopySpdBtn.Enabled := true;
    PopupMenu1.Items[3].Enabled := true;
    PopupMenu1.Items[4].Enabled := true;
    PopupMenu1.Items[6].Enabled := true;
  end else begin
    EditCutMnu.Enabled := false;
    EditCopyMnu.Enabled := false;
    EditDeleteMnu.Enabled := false;
    CutSpdBtn.Enabled := false;
    CopySpdBtn.Enabled := false;
    PopupMenu1.Items[3].Enabled := false;
    PopupMenu1.Items[4].Enabled := false;
    PopupMenu1.Items[6].Enabled := false;
  end;
end;

procedure TMainForm.ShowToolBar (b : boolean);
begin
  if b = ToolBar.Visible then exit;

  ToolBar.Visible := b;
  if ToolBar.Visible then begin
    Edit.Top := 35;
    Edit.Height := Edit.Height - 35;
  end else begin
    Edit.Top := 0;
    Edit.Height := Edit.Height + 35;
  end;
  OptionsToolbarMnu.Checked := b;
end;

procedure TMainForm.OptionsRunMnuClick(Sender: TObject);
begin
  RunForm.ShowModal;
end;

procedure TMainForm.EditUndoMnuClick(Sender: TObject);
begin
  Edit.Perform (EM_Undo, 0, 0);
end;

procedure TMainForm.EditKeyPress(Sender: TObject; var Key: Char);
begin
  // causes overwright
{  if not Insert
  and (Edit.SelStart < Edit.GetTextLen)
  and not (Key in [#27, #13, #9, #8])
  and (Edit.Text[Edit.SelStart + 1] <> #13)
  and (Edit.SelLength = 0)
    then Edit.SelLength := 1;}
end;

procedure TMainForm.FilePrintSetupMnuClick(Sender: TObject);
begin
  PrinterSetupDialog1.Execute;
end;

procedure TMainForm.EditMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  LastStart := Edit.SelStart;
end;

procedure TMainForm.ExecuteDOSPromptMnuClick(Sender: TObject);
begin
  //SetCurrentDir (ExtractFilePath (FileName));
  //Execute ('Command.com');
  MakeTempBatFile (FileName, 'command.com', false);
  Execute (SourceDir + TempBatFileName);
end;

procedure TMainForm.OptionsExecuteMnuClick(Sender: TObject);
begin
  ExeOptForm.ShowModal;
end;

procedure TMainForm.ExecuteCurrentFileMnuClick(Sender: TObject);
var
  s, Params, Dir : string;
  i : SmallInt;
begin
  i := ExeOpts.IndexOfSource (ExtractFileExt (FileName));
  if i < 0 then begin
    ShowMsgDlg ('Use Options|Execute Menu to set an executable extension for extension "' + ExtractFileExt (FileName) + '"', mtWarning);
    exit;
  end;

  with ExeOpts.Items[i]^ do begin
    case SaveOrBackupIndex of
      0 : begin
        FileSaveMnu.Click;

        if Edit.Modified then //save was cancled
          if MessageDlg ('Still wish to execute Current File?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then
            exit;
      end;

      1 : begin
        FileSaveAllMnu.Click;

        {If any files are modified, some save
         must have been cancled}
        if AnyModified then
          if MessageDlg ('Still wish to execute Current File?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then
            exit;
      end;

      2 : FileBackupCurrentFileMnu.Click;
      3 : FileBackupAllFilesMnu.Click;
    end;//case

    s := ChangeExt (GetMainFile, ExeExt);

    {Assigns s the apprioriate file name
     taking into account the extension it
     should have}
    {case ExeIndex of
      0 : s := GetMainFile;
      1 : s := ChangeExt (GetMainFile, 'exe');
      2 : s := ChangeExt (GetMainFile, 'com');
      3 : s := GetBackupName (GetMainFile);
      4 : s := ChangeExt (GetMainFile, OtherExt);
    end;}

    if ParamsPrompt then
      if not InputQuery ('Parameters', 'Input Parameters for ' + s, Params) then begin
        if MessageDlg ('Still with to execute current file?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then
          exit;

        Params := '';
      end else
        s := s + ' ' + Params;

    if cd then begin
      dir := ExtractFilePath (s);
      if DirectoryExists (dir) then
        chdir (dir);
        //dir := ''
    end;

    //ShellExecute (0, Nil, PChar (s), PChar (Params), PChar (Dir), GetShowCmd (s));
    //ShellExe (s);
    if Execute (s) = 0 then begin
      //s := ExtractFileExt (s);
      //if not (StrCmp (s, '.exe') or StrCmp (s, '.com') or StrCmp (s, '.bat')) then
      //  ShowMsgDlg ('"Execute|Current File" should only be used for exe, com, or bat files. The two most common cuases of  this problem are:' + pb +
      //               '1. The file needs another application to run, and use the "Run" menu.' + cr +
      //               '2. Options|Execute Menu|Execute As is not set right', mtWarning);
    end;
  end;//with ExeOptRec...

end;

procedure TMainForm.FileReloadMnuClick(Sender: TObject);
begin
  if CanOpen (FileName, true) <> coTrue then exit;

  if ConfirmPrompt then
    if MessageDlg ('Reload "' + FileName + '"?',
                    mtConfirmation, [mbYes, mbNo], 0)
      = mrNo then exit;

  //FileSaveMnu.Default := true;
  Edit.Lines.LoadFromFile (FileName);
  ChangeModify (false);
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
  Edit.Perform (EM_ScrollCaret, 0, 0);
end;

procedure TMainForm.EditDeleteLineMnuClick(Sender: TObject);
begin
  Edit.Lines.Delete (Edit.Perform (EM_LineFromChar, -1, 0));
end;

procedure TMainForm.ExecuteDOSComMnuClick(Sender: TObject);
var command : string;
begin
  if InputQuery ('DOS Command', 'Input a DOS Command to be executed', command) then
  begin
    MakeTempBatFile (FileName, command, true);
    Execute (SourceDir + TempBatFileName);
  end;
end;

procedure TMainForm.ChangeReadOnly (b : boolean);
begin
  Edit.ReadOnly := b;
  OptionsReadOnlyMnu.Checked := b;
end;

procedure TMainForm.OptionsReadOnlyMnuClick(Sender: TObject);
begin
  ChangeReadOnly (not Edit.ReadOnly);
end;

function TMainForm.OpenParam : boolean;
var
  s : string;
  i : byte;
begin
  if ParamCount < 1 then begin
    result := false;
    exit;
  end;

  s := '';
  for i := 1 to ParamCount do begin
    s := s + ParamStr (i);
    if (i < ParamCount) then
      s := s + #32;
  end;

  result := OpenFile (s, true) = coTrue;
end;

procedure TMainForm.HelpAboutMnuClick(Sender: TObject);
begin
  AboutForm.ShowModal;
end;

procedure TMainForm.EditMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  EnableCutCopy;
  WriteCursPos;
end;

procedure TMainForm.UpDown1Click(Sender: TObject; Button: TUDBtnType);
var
  Shift : SmallInt;
  i : byte;
begin
  if Button = btPrev then
    Shift := - NewSpdBtn.Width
  else
    Shift := NewSpdBtn.Width;

  with ToolBar do
    for i := 0 to ControlCount - 1 do
      if Controls[i] <> UpDown1 then
        Controls[i].Left := Controls[i].Left + Shift;
end;

procedure TMainForm.EditCutLineMnuClick(Sender: TObject);
begin
  Edit.SelStart := Edit.Perform (EM_LineIndex, -1, 0);
  Edit.SelLength := length (Edit.Lines[Edit.Perform (EM_LineFromChar, -1, 0)]) + 2;
  Edit.CutToClipboard;
  CBtoPanel;
end;

procedure TMainForm.OptionsScrollBarsMnuClick(Sender: TObject);
begin
  OptionsScrollBarsMnu.Checked := not OptionsScrollBarsMnu.Checked;
  SetScrollBars;
end;

{function TMainForm.FileTooBig (fName : TFileName): boolean;
var SearchRec : TSearchRec;
begin
  FindFirst (fName, faAnyFile, SearchRec);
  result := SearchRec.Size > Word (-1);
end;}

function TMainForm.AnyModified : boolean;
var i : byte;
begin
    result := Edit.Modified;

    if FilesOpen > 1 then
      for i := 1 to FilesOpen - 1 do
        if Files[i]^.Modified then
          result := true;
end;

procedure TMainForm.OptionsToolbarMnuClick(Sender: TObject);
begin
  ShowToolBar (not OptionsToolbarMnu.Checked);
end;

function TMainForm.CanAddToRecent (const fName : TFileName) : boolean;
begin
  if not FileExists (fName) then begin
    result := false;
    exit;
  end;

  if InCurGroup (fName) then begin
    result := false;
    exit;
  end;

  if InFav (fName) >= 0 then begin
    result := false;
    exit;
  end;

  if IsOptionsFile (fname, false) then begin
    result := false;
    exit;
  end;

  result := true;
end;

function TMainForm.AddToRecent (const fName : TFileName; check : boolean) : boolean;
var
  i : byte;
  MenuItem : TRecentMenuItem;
begin
  {if check then checks are performed to see if
   fName can validly be added to recent}
  if check then begin
    result := CanAddToRecent (fName);
    if not result then exit;
  end else
    result := true;

  {Numbers are deleted from FileRecentMnu, the
   items are switched around appropriately,
   then the number are put back}
  DeleteRecentNums;
  with FileRecentMnu do begin
    {deletes menu item if it's already in
     FileRecentMnu}
    if Count > 0 then
      for i := 0 to Count - 1 do
        if StrCmpi (fName, CapToStr (Items[i].Caption)) then begin
          Delete (i);
          system.break;
        end;

    {Deletes the last item if FileRecentMnu
     is full}
    if Count = MaxRecentNum then Delete (Count - 1);

    MenuItem := TRecentMenuItem.Create (FileRecentMnu);
    MenuItem.Caption := fName;

    //add most recent item to top
    Insert (0, MenuItem);
  end;//with...
  AddRecentNums;
end;

//takes away the numbers in FileRecentMnu
procedure TMainForm.DeleteRecentNums;
var i : byte;
begin
  i := 0;

  with FileRecentMnu do
    while (i < Count) and (i < 10) do begin
      Items[i].Caption := CapToStr (Items[i].Caption);
      inc (i);
    end;
end;

//Numbers items in FileRecentMnu
procedure TMainForm.AddRecentNums;
var i : byte;
begin
  i := 0;

  with FileRecentMnu do
    while (i < Count) and (i < 10) do begin
      Items[i].Caption := StrToCap (Items[i].Caption, i + 1);
      inc (i);
    end;
end;

procedure TMainForm.FileMnuClick(Sender: TObject);
begin
  FileReloadMnu.Enabled := FileExists (FileName);
  FileRecentMnu.Enabled := FileRecentMnu.Count > 0;
  FileOpenGroupMnu.Enabled := FileOpenGroupMnu.Count > 0;
  FileFavoritesMnu.Enabled := FileFavoritesMnu.Count > 0;
  AddGroupMnu.Enabled := (GroupOpen > 0) and not InCurGroup (FileName);
  AddFavoritesMnu.Enabled := InFav (FileName) < 0;
  FileCloseGroupMnu.Enabled := GroupOpen > 0;
  FileSelectionMnu.Enabled := Edit.SelLength > 0;
end;

procedure TMainForm.OptionsOpenGroupMenuClick(Sender: TObject);
begin
  GroupForm.ShowModal;
end;

function TMainForm.IsOpen (const fName : TFileName) : boolean;
var i : byte;
begin
  if fName = FileName then begin
    result := true;
    exit;
  end;

  if FilesOpen > 1 then
    for i := 1 to FilesOpen - 1 do
      if fName = Files[i]^.FileName then begin
        result := true;
        exit;
      end;

  result := false;
end;

function TMainForm.RemoveFromRecent (const fName : TFileName) : boolean;
var i : integer;
begin
  i := RecentPos (fName);

  result := i >= 0;
  if not result then exit;

  with FileRecentMnu.Items[i] do begin
    tag := 1;//signal for click to remove item
    Click;
    tag := 0;
  end;
end;

function TMainForm.RecentPos (const fName : TFileName) : integer;
var i : integer;
begin
  with FileRecentMnu do
    if Count > 0 then
      for i := 0 to Count - 1 do
        if StrCmpi (fName, CapToStr (Items[i].Caption)) then begin
          result := i;
          exit;
        end;

  result := -1;
end;

procedure TMainForm.FileCloseGroupMnuClick(Sender: TObject);
begin
  CloseOpenGroup;
end;

//returns true only if all files in group are closed
function TMainForm.CloseOpenGroup : boolean;
var i, j : byte;
begin
  if FilesOpen = 0 then begin
    result := true;
    exit
  end else if FilesOpen > 1 then begin
    //close files other than current file first
    //first save all changes
    for i := 1 to FilesOpen - 1 do
      if Files[i]^.Modified and InCurGroup (Files[i]^.FileName) then
        if SaveChanges (i) = mrCancel then begin
          result := false;
          exit;
        end;

    {separates non group members of Files and puts then at
     the top of Files array; items in the ViewMnu will be
     handled with the files}
    j := 1;
    for i := 1 to FilesOpen - 1 do
      if not InCurGroup (Files[i]^.FileName) then begin
        if i > j then begin
          Files[j]^.Assign (Files[i]^);
          ViewMnu.Items[j + DefViewNum - 1].Assign (ViewMnu.Items[i + DefViewNum - 1]);
        end;

        inc (j);
      end;

    //destroyes the top non group members of Files
      for i := FilesOpen - 1 downto j do begin
        Dispose (Files[i]);
        ViewMnu.remove (ViewMnu.Items[i + DefViewNum - 1]);
      end;

    FilesOpen := j;
  end;//if FilesOpen > 1...

  if InCurGroup (FileName) then
    result := CloseCurFile
  else
    result := true;

  EnableView;
  GroupOpen := 0;
end;

function TMainForm.InCurGroup (const fName : TFileName) : boolean;
var i : byte;
begin
  if GroupOpen = 0 then begin
    result := false;
    exit;
  end;

  with groups[GroupOpen]^ do
    for i := 0 to Count - 1 do
      if StrCmpi (Strings[i], fName) then begin
        result := true;
        exit;
      end;

  result := false;
end;

procedure TMainForm.FileCopyMnuClick(Sender: TObject);
begin
  CMForm.mode := cmCopy;
  CMForm.ShowModal;
end;

procedure TMainForm.FileMoveMnuClick(Sender: TObject);
begin
  CMForm.mode := cmMove;
  CMForm.ShowModal;
end;

function TMainForm.ChangeGroupFile (const f1, f2 : TFileName) : boolean;
begin
  if GroupOpen = 0 then begin
    result := false;
    exit;
  end;

  if groups[GroupOpen]^.IndexOf (f1) = -1 then begin
    if IsUntitled (f1) then
      result := AddToGroup (f2, true)
    else
      result := false;
  end else
    if MessageDlg ('Do you wish to change "' + f1 + '" to "' + f2 + '" in the current group?',
                   mtConfirmation, [mbYes, mbNo], 0) = mrNo then
      result := false
    else begin
      groups[GroupOpen].Strings[groups[GroupOpen].IndexOf (f1)] := f2;
      result := true;
    end;
end;

procedure TMainForm.FileRenameMnuClick(Sender: TObject);
var fName : TFileName;
begin
  fName := ExtractFileName (FileName);
  if not InputQuery ('Rename', 'Rename "' + ExtractFileName (FileName) + '" to:', fName) then exit;
  if ExtractFilePath (fName) <> '' then begin
    ShowMsgDlg ('You should use "Move" if you want to change to location as well as the name of a file', mtWarning);
    exit;
  end;

  fName := ExtractFilePath (FileName) + fName;
  if FileExists (fName) then begin
    if MessageDlg ('File "' + fName + '" exists.  Overwright?',
                   mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
      if not DeleteFile (fName) then begin
        ShowMsgDlg ('File "' + fName + '" could not be delete so file "' + FileName + '" could be renamed', mtError);
        exit;
      end;
    end else
      exit;
  end;

  if not RenameFile (FileName, fName) then begin
    ShowMsgDlg ('File "' + FileName + '" could not be renamed', mtError);
    exit;
  end;

  ChangeGroupFile (FileName, fName);
  ChangeFavFile (FileName, fName);
  ChangeRecentFile (FileName, fName);
  FileName := fName;
end;

procedure TMainForm.FileDeleteMnuClick(Sender: TObject);
begin
  if ConfirmPrompt then
    if MessageDlg ('Sure you want to DELETE "' + FileName + '"?',
                   mtConfirmation, [mbYes, mbNo], 0) = mrNo then exit;

  if not DeleteFile (FileName) then begin
    ShowMsgDlg ('Could not delete "' + FileName + '"', mtError);
    exit;
  end;

  RemoveFromRecent (FileName);
  RemoveFromGroup (FileName);
  Edit.Modified := false;
  CloseCurFile;
end;

function TMainForm.RemoveFromGroup (const fName : TFileName) : boolean;
begin
  if not InCurGroup (fName) then begin
    result := false;
    exit;
  end;

  if MessageDlg ('Do you want to REMOVE "' + fName + '" from the open group?',
                 mtConfirmation, [mbYes, mbNo], 0) = mrNo then begin
    result := false;
    exit;
  end;

  with groups[GroupOpen]^ do
    Delete (IndexOf (fName));

  result := true;
end;

function TMainForm.AddToGroup (const fName : TFileName; b : boolean) : boolean;
begin
  if GroupOpen = 0 then begin
    result := false;
    exit;
  end;

  if InCurGroup (fName) then begin
    result := false;
    exit;
  end;

  if b then
    if MessageDlg ('Do you wish to add "' + fName + '" to group "' + CapToStr (FileOpenGroupMnu.Items[GroupOpen - 1].Caption) + '"?',
                   mtConfirmation, [mbYes, mbNo], 0) = mrNo then begin
      result := false;
      exit;
    end;

  groups[GroupOpen]^.Add (fName);
  result := true;
end;

procedure TMainForm.OptionsOpenFavoritesMnuClick(Sender: TObject);
begin
  FavForm.ShowModal;
end;

function TMainForm.AddToFav (const fName : TFileName) : boolean;
var MenuItem : TFavMenuItem;
begin
  if FileFavoritesMnu.Count >= MaxFiles then begin
    result := false;
    exit;
  end;

  if InFav (fName) >= 0 then begin
    result := false;
    ShowMsgDlg ('"' + fName + '" is already in favorites', mtWarning);
    exit;
  end;

  RemoveFromRecent (fName);

  MenuItem := TFavMenuItem.Create (FileFavoritesMnu);
  MenuItem.Caption := StrToCap (fName, FileFavoritesMnu.Count + 1);

  FileFavoritesMnu.Add (MenuItem);
  result := true;
end;

{returns the position of fName in favorites; returns 0 if
 fName is not in favorites}
function TMainForm.InFav (const fName : TFileName) : SmallInt;
var i : byte;
begin
  with FileFavoritesMnu do begin
    if Count = 0 then begin
      result := -1;
      exit;
    end;

    for i := 0 to Count - 1 do
      if StrCmpi (CapToStr (fName), CapToStr (Items[i].Caption)) then begin
        result := i;
        exit;
      end;

  end;//with...
  result := -1;
end;

function TMainForm.ChangeFavFile (const OldName, NewName : TFileName) : boolean;
var i : SmallInt;
begin
  i := InFav (OldName);
  if i = -1 then begin
    result := false;
    exit;
  end;

  if ConfirmPrompt then
    if MessageDlg ('Do you wish to change "' + OldName + '" to "' + NewName + '" in the favorites menu?',
                   mtConfirmation, [mbYes, mbNo], 0) = mrNo then begin
      result := false;
      exit;
    end;

  FileFavoritesMnu.Items[i].Caption := StrToCap (NewName, i + 1);
  result := true;
end;

function TMainForm.ChangeRecentFile (const OldName, NewName : TFileName) : boolean;
var i : integer;
begin
  i := RecentPos (OldName);
  if i = -1 then begin
    result := false;
    exit;
  end;

  if ConfirmPrompt then
    if MessageDlg ('Do you wish to change "' + OldName + '" to "' + NewName + '" is File|Recent?',
                   mtConfirmation, [mbYes,mbNo], 0) = mrNo then begin
      result := false;
      exit;
    end;

  FileRecentMnu.Items[i].Caption := StrToCap (NewName, i + 1);
  result := true;
end;

//returns true only if all files are closed
function TMainForm.CloseAllFiles : boolean;
var i : byte;
begin
  if FilesOpen = 0 then begin
    result := true;
    exit
  end else if FilesOpen > 1 then begin
    //close files other than current file first
    //first save all changes
    for i := 1 to FilesOpen - 1 do
      if Files[i]^.Modified then
        if SaveChanges (i) = mrCancel then begin
          result := false;
          exit;
        end;

    for i := FilesOpen - 1 downto 1 do begin
      AddToRecent (Files[i]^.FileName, true);
      Dispose (Files[i]);
    end;

    FilesOpen := 1;

    //empty view menu
    while (ViewMnu.Count > DefViewNum) do ViewMnu.Delete (ViewMnu.Count - 1);
  end;//if FilesOpen > 1...

  EnableView;
  result := CloseCurFile;
  GroupOpen := 0;
end;

procedure TMainForm.HelpContentsMnuClick(Sender: TObject);
begin
  Application.HelpContext (1);
end;

procedure TMainForm.OptionsHintsMnuClick(Sender: TObject);
begin
  HintForm.ShowModal;
end;

procedure TMainForm.ViewSelectFileMnuClick(Sender: TObject);
begin
  ViewForm.ShowModal;
end;

procedure TMainForm.ShowStatusBar (b : boolean);
begin
  OptionsStatusMnu.Checked := b;
  if b then
    StatusBar1.Height := 16
  else
    StatusBar1.Height := 0;
  Resize;
end;

procedure TMainForm.OptionsStatusMnuClick(Sender: TObject);
begin
  ShowStatusBar (not OptionsStatusMnu.Checked);
end;

procedure TMainForm.FileBackupMnuClick(Sender: TObject);
begin
  FileBackupAllFilesMnu.Enabled := FilesOpen > 1;
end;

procedure TMainForm.FileBackupCurrentFileMnuClick(Sender: TObject);
var fName : TFileName;
begin
  if FilesOpen = 0 then exit;

  if IsReadOnly (fName) then begin
    ShowMsgDlg ('This is a readonly file.  If you want to back this file up, use a different name.', mtWarning);
    exit;
  end;

  fName := GetBackupName (FileName);
  Edit.Lines.SaveToFile (fName);
end;

procedure TMainForm.FileBackupAllFilesMnuClick(Sender: TObject);
var
  i : byte;
  FileVar : TextFile;
begin
  FileBackupCurrentFileMnu.Click;
  if FilesOpen < 2 then exit;

  for i := 1 to FilesOpen - 1 do begin
    AssignFile (FileVar, GetBackupName (files[i].FileName));
    Rewrite (FileVar);
      Write (FileVar, files[i].Text);
    CloseFile (FileVar);
  end;
end;

procedure TMainForm.FileCloseCurrentFileMnuClick(Sender: TObject);
begin
  if InCurGroup (FileName) then
    if PersistentGroups then begin
      CloseOpenGroup;
      exit;
    end else
      case MessageDlg ('"' + FileName + '" is in the group currently open.  Do you want to close the ENTIRE group instead of just this file?',
        mtConfirmation, mbYesNoCancel, 0) of
        mrYes : begin
          CloseOpenGroup;
          exit;
        end;

        mrCancel : exit;
      end;//case...

  CloseCurFile;
end;

procedure TMainForm.FileCloseAllFilesMnuClick(Sender: TObject);
begin
  CloseAllFiles;
end;

procedure TMainForm.FileInsertMnuClick(Sender: TObject);
var
  text : string;
  hSS : cardinal;
begin
  //make OpenDialog an InsertDialog
  OpenDialog1.Title := 'Insert';
  OpenDialog1.Options :=
    OpenDialog1.Options + [ofHideReadOnly];

  if not OpenDialog1.execute then begin
    //change back to open dialog
    OpenDialog1.Title := '';
    OpenDialog1.Options :=
      OpenDialog1.Options - [ofHideReadOnly];

    exit;
  end;
  //change back to open dialog
  OpenDialog1.Title := '';
  OpenDialog1.Options :=
    OpenDialog1.Options - [ofHideReadOnly];

  if CanOpen (OpenDialog1.FileName, true) <> coTrue then exit;

  hSS := Edit.SelStart;

  text := Edit.Text;
  System.Insert (FileToStr (OpenDialog1.FileName), text, Edit.SelStart);
  Edit.Text := text;

  Edit.SelStart := hSS;
  OpenDialog1.InitialDir := ExtractFilePath (OpenDialog1.FileName);
end;

procedure TMainForm.FileUnbackupCurrentFileMnuClick(Sender: TObject);
begin
  DeleteFile (GetBackupName (FileName));
end;

procedure TMainForm.FileUnbackupAllFilesMenuClick(Sender: TObject);
var i : byte;
begin
  FileUnbackupCurrentFileMnu.Click;

  if FilesOpen > 1 then
    for i := 1 to FilesOpen - 1 do
      DeleteFile (GetBackupName (files[i].FileName));
end;

procedure TMainForm.FileReplaceCurrentFileMnuClick(Sender: TObject);
begin
  {So CanOpen will not return coMaxFiles}
  dec (FilesOpen);
  if CanOpen (GetBackupName (FileName), true) = coTrue then
    Edit.Lines.LoadFromFile (GetBackupName (FileName));
    //Edit.Modified := true;

  inc (FilesOpen);
  WriteModified;
end;

procedure TMainForm.FileReplaceAllFilesMnuClick(Sender: TObject);
var i : byte;
begin
  {So CanOpen will not return coMaxFiles}
  dec (FilesOpen);
  for i := 1 to FilesOpen do
    if CanOpen (GetBackupName (Files[i]^.FileName), true) = coTrue then begin
      Files[i]^.Text := FileToStr (GetBackupName (Files[i]^.FileName));
      Files[i]^.Modified := true;
    end;

  inc (FilesOpen);

  {since the next procedure calls WriteModifed,
   put it here instead of at the top keep
   WriteModified from having to be called
   twice}
  FileReplaceCurrentFileMnu.Click;
end;

{procedure TMainForm.Highlight (start, stop : cardinal);
var
  i, Nstart : cardinal;
  j : integer;
  StartTime : real;
begin
  StartTime := Timer;

  if KeyWords.Items.Count = 0 then exit;

  Hide;
  with Edit do begin
    //hSelStart := SelStart;

    for i := 0 to KeyWords.Items.Count - 1 do begin
      j := start;

      while j < stop do begin
        j := FindText (KeyWords.Items[i], j, stop - j + 1, KeyWords.SearchTypesAry[i]^);
        if j < 0 then break;

        Nstart := j + length (KeyWords.Items[i]);
        Perform (EM_SETSEL, j, Nstart);
        j := Nstart;
        SelAttributes.Color := clWhite;
      end;// while...
    end; // for...
    //SelStart := hSelStart;
  end; // with...
  Show;
  ShowMessage (FloatToStr (Timer - StartTime));
end;

procedure TMainForm.Highlight2 (start, stop : cardinal);
var
  i1, LowestPos : cardinal;
  i2, LowestIndex : integer;
begin
  if KeyWords.Items.Count = 0 then exit;

  Edit.Hide;
  while start <= stop do begin
    LowestPos := Edit.GetTextLen + 1;
    LowestIndex := -1;
    for i1 := 0 to KeyWords.Items.Count - 1 do begin
      i2 := Edit.FindText (KeyWords.Items[i1], start, stop - start + 1, KeyWords.SearchTypesAry[i1]^);
      if (i2 >= 0) and (i2 < LowestPos) then begin
        LowestIndex := i1;
        LowestPos := i2;
      end;
    end;
    if LowestIndex = -1 then break;

    with Edit do begin
      SelStart := LowestPos;
      SelLength := length (KeyWords.Items[LowestIndex]);
      start := SelStart + SelLength;
      SelAttributes.Color := clWhite;
      //SelLength := 0;
    end;
  end;// while...
  ShowEdit;
end;

procedure TMainForm.Highlight3 (start, stop : cardinal);
var
  i : integer;
  hSelStart, hSelLength : cardinal;
//  StartTime : real;
begin
//  StartTime := Timer;

  //Edit.Hide;

  hSelStart := Edit.SelStart;
  hSelLength := Edit.SelLength;

  //Edit.SelAttributes.Color := clWhite;

  for i := 0 to KeyWords.Items.Count - 1 do
    DoHighlight2 (start, stop, i);

  Edit.SelLength := 0;
  Edit.SelAttributes.Color := Edit.Font.Color;

  Edit.SelStart := hSelStart;
  Edit.SelLength := hSelLength;

  //ShowEdit;
//  ShowMessage (FloatToStr (Timer - StartTime));
end;

procedure TMainForm.DoHighlight2 (start, stop : cardinal; i : integer);
var FindResult : integer;
begin
  if start >= stop then exit;

  with Edit do begin
    FindResult := FindText (KeyWords.Items[i], start, stop - start + 1, KeyWords.SearchTypesAry[i]^);

    if FindResult < 0 then exit;

    start := FindResult + length (KeyWords.Items[i]);
    Perform (EM_SETSEL, FindResult, start);
    SelAttributes.Style := [fsBold];//Color := clWhite;
    SelAttributes.Color := clWhite;
    DoHighlight2 (start, stop, i);
  end;
end;

procedure TMainForm.DoHighlight (start, stop : cardinal; i : integer);
var
  len : cardinal;
  j : integer;
begin
  if start >= stop then exit;
  with Edit do begin
    len := length (KeyWords.Items[i]);
    j := FindText (KeyWords.Items[i], start, 2 * len, KeyWords.SearchTypesAry[i]^);

    if j < 0 then
      DoHighlight (start + 2 * len, stop, i)
    else begin
      //SelLength := len;
      Edit.Perform (EM_SETSEL, j, j + len);
      SelAttributes.Style := [fsBold];// := clWhite;
      SelAttributes.Color := clWhite;
      DoHighlight (j +  len, stop, i);
    end;
  end;
end;}

function TMainForm.GetCaretY : cardinal;
begin
  {Returns the Y coordinate of the caret
   reletive to the screen}
  with Edit do
    result := (Perform (EM_LINEFROMCHAR, -1, 0)
      - Perform (EM_GETFIRSTVISIBLELINE, 0, 0))
      * abs (Font.Height) + Top + MainForm.Top;
end;

procedure TMainForm.ShowFoundDlg (FoundOne : boolean);
begin
  if FoundOne then
    ShowMsgDlg ('No more matches for "' + FindText + '" found', mtInformation)
  else
    ShowMsgDlg ('Search string "' + FindText + '" not found', mtInformation);
end;

//takes Params and changes things like PR_TOKEN to FileName
function TMainForm.ExpandParams (var Params : string) : boolean;
var
  FindStr, InParams : string;
  i : cardinal;
  ReplaceSet : set of char;

  //returns the string that $* will be replaced with
  function GetReplaceStr : string;
  begin
    result := GetMainFile;
    //PR_DOS_NAME must come first
    if PR_DOS_NAME in ReplaceSet then result := GetDosName (result);
    if PR_REMOVE_EXTENSION in ReplaceSet then result := ChangeExt (result, '');
    if PR_EXTRACT_PATH in ReplaceSet then result := ExtractFilePath (result);
    if PR_REMOVE_PATH in ReplaceSet then result := ExtractFileName (result);
  end;

begin
  i := Pos (PR_TOKEN, Params);
  while i > 0 do begin
    FindStr := PR_TOKEN;
    ReplaceSet := [];

    while i < length (Params) do begin
      inc (i);
      if not (Params[i] in ValidFilePRs) then break;

      ReplaceSet := ReplaceSet + [Params[i]];
      FindStr := FindStr + Params[i];
    end;//while i < length...
  Replace (FindStr, GetReplaceStr, Params);
  i := Pos (PR_TOKEN, Params);
  end;//while i > 0...

  //replaces %p with parameters that were prompted for
  i := pos (PR_PROMPT, Params);
  while i > 0 do begin
    if not InputQuery ('Parameters', 'Input Parameters', InParams) then
      if MessageDlg ('Do you still want to execute this program', mtConfirmation, [mbYes, mbNo], 0) = mrNo then begin
        result := false;
        exit;
      end;

      Replace (PR_PROMPT, InParams, Params);
      i := pos (PR_PROMPT, Params);
    end;

  result := true;
end;

{METHODS OF OBJECTS OTHER THAN TMainForm;
 They're no in CE_Unit because they use
 TMainForm}

procedure TViewMenuItem.Assign (Source : TPersistent);
var MenuItem : TViewMenuItem;
begin
  MenuItem := TViewMenuItem (Source);
  Caption := StrToCap (CapToStr (MenuItem.Caption), Tag);
end;

procedure TViewMenuItem.Click;
begin
  Caption := StrToCap (MainForm.FileName, Tag);
  MainForm.SwapMemoAry (Tag);
end;

procedure TRunMenuItem.Click;
var Params, BatFile : string;
begin
  with MainForm do
    if FilesOpen > 0 then
      case Progs[Self.Tag]^.SaveOrBackupIndex of
        0 : begin
        FileSaveMnu.Click;

          if Edit.Modified then //save was cancled
            if MessageDlg ('Still wish to Run Program?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then
              exit;
        end;

        1 : begin
          FileSaveAllMnu.Click;

          {If any files are modified, some save
           must have been cancled}
          if AnyModified then
            if MessageDlg ('Still wish to Run Program?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then
              exit;
        end;

        2 : FileBackupCurrentFileMnu.Click;
        3 : FileBackupAllFilesMnu.Click;
      end;//case

  Params := MainForm.Progs[Tag]^.Params;
  if not MainForm.ExpandParams (Params) then exit;
  Params := MainForm.Progs[Tag]^.Prog + ' ' + Params;
  {

  case MainForm.Progs[Tag]^.FileNameParam of
    0 : Params := Params + ' ' + MainForm.FileName;
    1 : Params := Params + ' ' + ChangeExt (MainForm.FileName, '');
    2 : Params := Params + ' ' + MainForm.GetBackupName (MainForm.FileName);
  end;

  if MainForm.Progs[Tag]^.Params <> '' then
    Params := Params + ' ' + MainForm.Progs[Tag]^.Params;
  }

  if MainForm.Progs[Tag]^.BatFile.Text = '' then
    Execute (Params)
  else begin
    BatFile := MainForm.Progs[Tag]^.BatFile.Text;
    MainForm.ExpandParams (BatFile);
    ReplaceAll ('%cmd%', Params, BatFile);

    DeployBatFile (BatFile);
  end;
end;

procedure TRecentMenuItem.Click;
begin
  {since MainForm.RemoveFromRecent cannot call Suicide,
   it sets tag = 1 and calls click instead}
  if tag = 1 then
    Suicide
  else if MainForm.OpenFile (CapToStr (Caption), true) = coNotExists then
    Suicide;
end;

procedure TRecentMenuItem.Suicide;
var i : byte;
begin
  if MainForm.ConfirmPrompt then
    if MessageDlg ('Do you with to DELETE "' + CapToStr (Caption) + '" from the "File|Open Recent" menu?',
                   mtConfirmation, [mbYes, mbNo], 0) = mrNo then exit;

  i := MenuIndex + 1;
  with MainForm.FileRecentMnu do
    while (i <= 9) and (i < Count) do begin
      with Items[i] do
        Caption := StrToCap (CapToStr (Caption), i);

      inc (i);
    end;

  MainForm.FileRecentMnu.Remove (self);
end;

procedure TGroupMenuItem.Click;
var i : byte;
begin
  if MainForm.PersistentGroups then begin
    if not MainForm.CloseAllFiles then exit;
  end else if MainForm.GroupOpen <> MenuIndex + 1 then
    if not MainForm.CloseOpenGroup then exit;

  MainForm.GroupOpen := MenuIndex + 1;
  if MainForm.groups[MenuIndex + 1]^.Count > 0 then begin
    i := 0;
    while (i < MainForm.groups[MenuIndex + 1]^.Count) do
      if not MainForm.IsOpen (MainForm.groups[MenuIndex + 1]^[i]) then
        if MainForm.OpenFileBack (MainForm.groups[MenuIndex + 1]^[i], true, (i = 0) or not MainForm.Edit.Visible) <> coTrue then
          if MessageDlg ('Do you wish to DELETE "' +
                         MainForm.groups[MenuIndex + 1]^[i] +
                         '" from ' + CapToStr (Caption) + '?', mtConfirmation,
                         [mbYes, mbNo], 0) = mrYes then
            MainForm.groups[MenuIndex + 1]^.delete (i)
          else inc (i)
        else inc (i)
      else inc (i);
  end;// if...

//  if MainForm.FilesOpen = 0 then MainForm.GroupOpen := 0;
end;

procedure TGroupMenuItem.Assign (Source : TPersistent);
var
  i : cardinal;
  MenuItem : TMenuItem;
begin
  MenuItem := TMenuItem (Source);

  Caption := StrToCap (CapToStr (MenuItem.Caption), MenuIndex + 1);
  ShortCut := MenuItem.ShortCut;

  if MenuItem.Count = 0 then exit;
  for i := 0 to MenuItem.Count - 1 do
    Items[i].Caption := MenuItem[i].Caption;
end;

procedure TFavMenuItem.Click;
var fName : TFileName;
begin
  fName := CapToStr (MainForm.FileFavoritesMnu.Items[MenuIndex].Caption);
  if MainForm.OpenFile (fName, true) = coTrue then exit;
  if MainForm.ConfirmPrompt and (MessageDlg ('Do you wish to REMOVE "' + fName + '" from the favorites menu?',
                 mtConfirmation, [mbYes, mbNo], 0) = mrNo) then exit;
  Suicide;
end;

procedure TFavMenuItem.Suicide;
var i : byte;
begin
  i := MenuIndex + 1;
  with MainForm.FileFavoritesMnu do
    while (i <= 9) and (i < Count) do begin
      with Items[i] do
        Caption := StrToCap (CapToStr (Caption), i);

      inc (i);
    end;

  MainForm.FileFavoritesMnu.Remove (self);
end;

{Saves the currently selected text to a file}
procedure TMainForm.FileSelectionSaveMnuClick(Sender: TObject);
begin
  SaveDialog1.Title := 'Save Selection';

  if not SaveDialog1.execute then begin
    SaveDialog1.Title := '';
    exit;
  end;
  SaveDialog1.Title := '';

  if FileExists (SaveDialog1.FileName) then
    if MessageDlg (SaveDialog1.FileName + ' exists.  Overwrite?', mtWarning, [mbYes, mbNo], 0) = mrNo then
      exit; //Modified still = true

  SelectionToFile (SaveDialog1.FileName);
end;

{creates a new file and puts the text
 currently highlighted into it}
procedure TMainForm.FileSelectionOpenMnuClick(Sender: TObject);
var HoldSel : string;
begin
  HoldSel := Edit.SelText;
  FileNewMnu.Click;
  Edit.Text := HoldSel;
end;

procedure TMainForm.EditSwapClipMnuClick(Sender: TObject);
const SpareClip : string = '';//const is like C's static
var s : string;
begin
//  EditSwapClipMnu.Checked := not EditSwapClipMnu.Checked;
  s := SpareClip;
  SpareClip := Clipboard.AsText;
  Clipboard.AsText := s;
  CBtoPanel;
end;

procedure TMainForm.ExecuteExplorerMnuClick(Sender: TObject);
begin
  Execute ('Explorer ' + ExtractFilePath (FileName));
end;

procedure TMainForm.OptionsSyntaxMnuClick(Sender: TObject);
begin
  SyntaxForm.ShowModal;
end;

procedure TMainForm.ViewMainFileMnuClick(Sender: TObject);
var i : cardinal;
begin
  for i := DefViewNum to ViewMnu.Count - 1 do
    if StrCmpi (CapToStr (ViewMnu.Items[i].Caption), groups[GroupOpen]^.Strings[MainFile[GroupOpen]]) then
      ViewMnu.Items[i].Click;
end;

procedure TMainForm.AddFavoritesMnuClick(Sender: TObject);
begin
  AddToFav (FileName);
end;

procedure TMainForm.PopupMenu1Popup(Sender: TObject);
begin
  OpenGroupPopItem.Enabled := FileOpenGroupMnu.Count > 0;
  AddToPopItem.Items[0].Enabled := InFav (FileName) < 0;
  AddToPopItem.Items[1].Enabled := (GroupOpen > 0) and not InCurGroup (FileName);
  ClosePopItem.Items[2].Enabled := GroupOpen > 0;
end;

procedure TMainForm.OptionsPropertiesMnuClick(Sender: TObject);
begin
  PropertiesForm.ShowModal;
end;

procedure TMainForm.OptionsOpenRecentMmuClick(Sender: TObject);
begin
  RecentForm.ShowModal;
end;

procedure TMainForm.OptionsShowClipMnuClick(Sender: TObject);
begin
  with OptionsShowClipMnu do begin
    Checked := not Checked;
    if Checked then
      CBtoPanel
    else
      StatusBar1.Panels[PN_CLIP].Text := '';
  end;
end;

procedure TMainForm.EditIndentBlockMnuClick(Sender: TObject);
var i, start, stop, hSS, hSL : Integer;
begin
  with Edit do begin
    {ReadOnly files shouldn't be able to be modified like
     this, but the code here would modify it anyway}
    if ReadOnly then exit;

    start := Perform (EM_LINEFROMCHAR, -1, 0);
    stop := Perform (EM_LINEFROMCHAR, SelStart + SelLength - 1, 0);

    hSS := SelStart; hSL := SelLength;
    for i := start to stop do
      Lines[i] := ' ' + Lines[i];

    SelStart := hSS;
    if hSL > 0 then SelLength := hSL + stop - start + 1;
  end;//with
  WriteModified;
end;

procedure TMainForm.EditUnindentBlockMnuClick(Sender: TObject);
var deleted, i, stop, hSS, hSL : Integer;
begin
  with Edit do begin
    {ReadOnly files shouldn't be able to be modified like
     this, but the code here would modify it anyway}
    if ReadOnly then exit;

    //i acts as start now
    i := Perform (EM_LINEFROMCHAR, -1, 0);
    stop := Perform (EM_LINEFROMCHAR, SelStart + SelLength, 0);

    hSS := SelStart; hSL := SelLength;
    deleted := 0;
    while i <= stop do begin
      if (Lines[i] <> '') and (Lines[i][1] = ' ') then begin
        Lines[i] := copy (Lines[i], 2, length (Lines[i]) - 1);
        inc (deleted);
      end;
      inc (i);
    end;

    SelStart := hSS;
    if hSL > 0 then SelLength := hSL - deleted;
  end;//with
  WriteModified;
end;

end.
